// =================================================================================
// Please reformat the grammr file before a change commit. See remorph/core/README.md
// For formatting, see: https://github.com/mike-lischke/antlr-format/blob/main/doc/formatting.md

// $antlr-format alignTrailingComments true
// $antlr-format columnLimit 150
// $antlr-format maxEmptyLinesToKeep 1
// $antlr-format reflowComments false
// $antlr-format useTab false
// $antlr-format allowShortRulesOnASingleLine true
// $antlr-format allowShortBlocksOnASingleLine true
// $antlr-format minEmptyLines 0
// $antlr-format alignSemicolons ownLine
// $antlr-format alignColons trailing
// $antlr-format singleLineOverrulesHangingColon true
// $antlr-format alignLexerCommands true
// $antlr-format alignLabels true
// $antlr-format alignTrailers true
// =================================================================================
lexer grammar commonlex;

// TODO: Remove the use of DUMMY for unfinished Snoflake grammar productions
DUMMY:
    'DUMMY'
; // Dummy is not a keyword but rules reference it in unfinished Snowflake grammar - need to get rid

ABORT                                    : 'ABORT';
ABORT_AFTER_WAIT                         : 'ABORT_AFTER_WAIT';
ABORT_DETACHED_QUERY                     : 'ABORT_DETACHED_QUERY';
ABORT_STATEMENT                          : 'ABORT_STATEMENT';
ABSENT                                   : 'ABSENT';
ABSOLUTE                                 : 'ABSOLUTE';
ACCELERATED_DATABASE_RECOVERY            : 'ACCELERATED_DATABASE_RECOVERY';
ACCENT_SENSITIVITY                       : 'ACCENT_SENSITIVITY';
ACCESS                                   : 'ACCESS';
ACCOUNT                                  : 'ACCOUNT';
ACCOUNTADMIN                             : 'ACCOUNTADMIN';
ACCOUNTS                                 : 'ACCOUNTS';
ACTION                                   : 'ACTION';
ACTIVATION                               : 'ACTIVATION';
ACTIVE                                   : 'ACTIVE';
ADD                                      : 'ADD';
ADDRESS                                  : 'ADDRESS';
ADMIN_NAME                               : 'ADMIN_NAME';
ADMIN_PASSWORD                           : 'ADMIN_PASSWORD';
ADMINISTER                               : 'ADMINISTER';
AES                                      : 'AES';
AES_128                                  : 'AES_128';
AES_192                                  : 'AES_192';
AES_256                                  : 'AES_256';
AFFINITY                                 : 'AFFINITY';
AFTER                                    : 'AFTER';
AGGREGATE                                : 'AGGREGATE';
ALERT                                    : 'ALERT';
ALERTS                                   : 'ALERTS';
ALGORITHM                                : 'ALGORITHM';
ALL                                      : 'ALL';
ALL_CONSTRAINTS                          : 'ALL_CONSTRAINTS';
ALL_ERRORMSGS                            : 'ALL_ERRORMSGS';
ALL_INDEXES                              : 'ALL_INDEXES';
ALL_LEVELS                               : 'ALL_LEVELS';
ALLOW_CLIENT_MFA_CACHING                 : 'ALLOW_CLIENT_MFA_CACHING';
ALLOW_CONNECTIONS                        : 'ALLOW_CONNECTIONS';
ALLOW_DUPLICATE                          : 'ALLOW_DUPLICATE';
ALLOW_ENCRYPTED_VALUE_MODIFICATIONS      : 'ALLOW_ENCRYPTED_VALUE_MODIFICATIONS';
ALLOW_ID_TOKEN                           : 'ALLOW_ID_TOKEN';
ALLOW_MULTIPLE_EVENT_LOSS                : 'ALLOW_MULTIPLE_EVENT_LOSS';
ALLOW_OVERLAPPING_EXECUTION              : 'ALLOW_OVERLAPPING_EXECUTION';
ALLOW_PAGE_LOCKS                         : 'ALLOW_PAGE_LOCKS';
ALLOW_ROW_LOCKS                          : 'ALLOW_ROW_LOCKS';
ALLOW_SINGLE_EVENT_LOSS                  : 'ALLOW_SINGLE_EVENT_LOSS';
ALLOW_SNAPSHOT_ISOLATION                 : 'ALLOW_SNAPSHOT_ISOLATION';
ALLOWED                                  : 'ALLOWED';
ALLOWED_ACCOUNTS                         : 'ALLOWED_ACCOUNTS';
ALLOWED_DATABASES                        : 'ALLOWED_DATABASES';
ALLOWED_INTEGRATION_TYPES                : 'ALLOWED_INTEGRATION_TYPES';
ALLOWED_IP_LIST                          : 'ALLOWED_IP_LIST';
ALLOWED_SHARES                           : 'ALLOWED_SHARES';
ALLOWED_VALUES                           : 'ALLOWED_VALUES';
ALTER                                    : 'ALTER';
ALWAYS                                   : 'ALWAYS';
AND                                      : 'AND';
ANONYMOUS                                : 'ANONYMOUS';
ANSI_DEFAULTS                            : 'ANSI_DEFAULTS';
ANSI_NULL_DEFAULT                        : 'ANSI_NULL_DEFAULT';
ANSI_NULL_DFLT_OFF                       : 'ANSI_NULL_DFLT_OFF';
ANSI_NULL_DFLT_ON                        : 'ANSI_NULL_DFLT_ON';
ANSI_NULLS                               : 'ANSI_NULLS';
ANSI_PADDING                             : 'ANSI_PADDING';
ANSI_WARNINGS                            : 'ANSI_WARNINGS';
ANY                                      : 'ANY';
API                                      : 'API';
API_ALLOWED_PREFIXES                     : 'API_ALLOWED_PREFIXES';
API_AWS_ROLE_ARN                         : 'API_AWS_ROLE_ARN';
API_BLOCKED_PREFIXES                     : 'API_BLOCKED_PREFIXES';
API_INTEGRATION                          : 'API_INTEGRATION';
API_KEY                                  : 'API_KEY';
API_PROVIDER                             : 'API_PROVIDER';
APPEND                                   : 'APPEND';
APPEND_ONLY                              : 'APPEND_ONLY';
APPLICATION                              : 'APPLICATION';
APPLICATION_LOG                          : 'APPLICATION_LOG';
APPLY                                    : 'APPLY';
ARITHABORT                               : 'ARITHABORT';
ARITHIGNORE                              : 'ARITHIGNORE';
ARRAY                                    : 'ARRAY';
ARRAY_AGG                                : 'ARRAY' '_'? 'AGG';
AS                                       : 'AS';
ASC                                      : 'ASC';
ASSEMBLY                                 : 'ASSEMBLY';
ASYMMETRIC                               : 'ASYMMETRIC';
ASYNCHRONOUS_COMMIT                      : 'ASYNCHRONOUS_COMMIT';
AT_KEYWORD                               : 'AT';
ATTACH                                   : 'ATTACH';
AUDIT                                    : 'AUDIT';
AUDIT_GUID                               : 'AUDIT_GUID';
AUTHENTICATE                             : 'AUTHENTICATE';
AUTHENTICATION                           : 'AUTHENTICATION';
AUTHORIZATION                            : 'AUTHORIZATION';
AUTHORIZATIONS                           : 'AUTHORIZATIONS';
AUTO                                     : 'AUTO';
AUTO_CLEANUP                             : 'AUTO_CLEANUP';
AUTO_CLOSE                               : 'AUTO_CLOSE';
AUTO_COMPRESS                            : 'AUTO_COMPRESS';
AUTO_CREATE_STATISTICS                   : 'AUTO_CREATE_STATISTICS';
AUTO_DETECT                              : 'AUTO_DETECT';
AUTO_DROP                                : 'AUTO_DROP';
AUTO_INGEST                              : 'AUTO_INGEST';
AUTO_REFRESH                             : 'AUTO_REFRESH';
AUTO_RESUME                              : 'AUTO_RESUME';
AUTO_SHRINK                              : 'AUTO_SHRINK';
AUTO_SUSPEND                             : 'AUTO_SUSPEND';
AUTO_UPDATE_STATISTICS                   : 'AUTO_UPDATE_STATISTICS';
AUTO_UPDATE_STATISTICS_ASYNC             : 'AUTO_UPDATE_STATISTICS_ASYNC';
AUTOCOMMIT                               : 'AUTOCOMMIT';
AUTOCOMMIT_API_SUPPORTED                 : 'AUTOCOMMIT_API_SUPPORTED';
AUTOGROW_ALL_FILES                       : 'AUTOGROW_ALL_FILES';
AUTOGROW_SINGLE_FILE                     : 'AUTOGROW_SINGLE_FILE';
AUTOINCREMENT                            : 'AUTOINCREMENT';
AUTOMATED_BACKUP_PREFERENCE              : 'AUTOMATED_BACKUP_PREFERENCE';
AUTOMATIC                                : 'AUTOMATIC';
AVAILABILITY                             : 'AVAILABILITY';
AVAILABILITY_MODE                        : 'AVAILABILITY_MODE';
AVRO                                     : 'AVRO';
AWS_KEY_ID                               : 'AWS_KEY_ID';
AWS_ROLE                                 : 'AWS_ROLE';
AWS_SECRET_KEY                           : 'AWS_SECRET_KEY';
AWS_SNS                                  : 'AWS_SNS';
AWS_SNS_ROLE_ARN                         : 'AWS_SNS_ROLE_ARN';
AWS_SNS_TOPIC                            : 'AWS_SNS_TOPIC';
AWS_SNS_TOPIC_ARN                        : 'AWS_SNS_TOPIC_ARN';
AWS_TOKEN                                : 'AWS_TOKEN';
AZURE_AD_APPLICATION_ID                  : 'AZURE_AD_APPLICATION_ID';
AZURE_EVENT_GRID                         : 'AZURE_EVENT_GRID';
AZURE_EVENT_GRID_TOPIC_ENDPOINT          : 'AZURE_EVENT_GRID_TOPIC_ENDPOINT';
AZURE_SAS_TOKEN                          : 'AZURE_SAS_TOKEN';
AZURE_STORAGE_QUEUE_PRIMARY_URI          : 'AZURE_STORAGE_QUEUE_PRIMARY_URI';
AZURE_TENANT_ID                          : 'AZURE_TENANT_ID';
BACKUP                                   : 'BACKUP';
BACKUP_CLONEDB                           : 'BACKUP_CLONEDB';
BACKUP_PRIORITY                          : 'BACKUP_PRIORITY';
BEFORE                                   : 'BEFORE';
BEGIN                                    : 'BEGIN';
BEGIN_DIALOG                             : 'BEGIN_DIALOG';
BERNOULLI                                : 'BERNOULLI';
BETWEEN                                  : 'BETWEEN';
BINARY                                   : 'BINARY';
BINARY_AS_TEXT                           : 'BINARY_AS_TEXT';
BINARY_FORMAT                            : 'BINARY_FORMAT';
BINARY_INPUT_FORMAT                      : 'BINARY_INPUT_FORMAT';
BINARY_OUTPUT_FORMAT                     : 'BINARY_OUTPUT_FORMAT';
BINDING                                  : 'BINDING';
BLOB_STORAGE                             : 'BLOB_STORAGE';
BLOCK                                    : 'BLOCK';
BLOCKED_IP_LIST                          : 'BLOCKED_IP_LIST';
BLOCKED_ROLES_LIST                       : 'BLOCKED_ROLES_LIST';
BLOCKERS                                 : 'BLOCKERS';
BLOCKSIZE                                : 'BLOCKSIZE';
BODY                                     : 'BODY';
BREAK                                    : 'BREAK';
BROKER                                   : 'BROKER';
BROKER_INSTANCE                          : 'BROKER_INSTANCE';
BROTLI                                   : 'BROTLI';
BROWSE                                   : 'BROWSE';
BUFFER                                   : 'BUFFER';
BUFFERCOUNT                              : 'BUFFERCOUNT';
BULK                                     : 'BULK';
BULK_LOGGED                              : 'BULK_LOGGED';
BUSINESS_CRITICAL                        : 'BUSINESS_CRITICAL';
BY                                       : 'BY';
BZ2                                      : 'BZ2';
CACHE                                    : 'CACHE';
CALL                                     : 'CALL';
CALLED                                   : 'CALLED';
CALLER                                   : 'CALLER';
CAP_CPU_PERCENT                          : 'CAP_CPU_PERCENT';
CASCADE                                  : 'CASCADE';
CASE                                     : 'CASE';
CASE_INSENSITIVE                         : 'CASE_INSENSITIVE';
CASE_SENSITIVE                           : 'CASE_SENSITIVE';
CAST                                     : 'CAST';
CATALOG                                  : 'CATALOG';
CATCH                                    : 'CATCH';
CERTIFICATE                              : 'CERTIFICATE';
CHANGE                                   : 'CHANGE';
CHANGE_RETENTION                         : 'CHANGE_RETENTION';
CHANGE_TRACKING                          : 'CHANGE_TRACKING';
CHANGES                                  : 'CHANGES';
CHANGETABLE                              : 'CHANGETABLE';
CHANNELS                                 : 'CHANNELS';
CHARACTER                                : 'CHARACTER';
CHECK                                    : 'CHECK';
CHECK_EXPIRATION                         : 'CHECK_EXPIRATION';
CHECK_POLICY                             : 'CHECK_POLICY';
CHECKALLOC                               : 'CHECKALLOC';
CHECKCATALOG                             : 'CHECKCATALOG';
CHECKCONSTRAINTS                         : 'CHECKCONSTRAINTS';
CHECKDB                                  : 'CHECKDB';
CHECKFILEGROUP                           : 'CHECKFILEGROUP';
CHECKPOINT                               : 'CHECKPOINT';
CHECKSUM                                 : 'CHECKSUM';
CHECKTABLE                               : 'CHECKTABLE';
CLASSIFIER_FUNCTION                      : 'CLASSIFIER_FUNCTION';
CLEANTABLE                               : 'CLEANTABLE';
CLEANUP                                  : 'CLEANUP';
CLONE                                    : 'CLONE';
CLONEDATABASE                            : 'CLONEDATABASE';
CLOSE                                    : 'CLOSE';
CLUSTER                                  : 'CLUSTER';
CLUSTERED                                : 'CLUSTERED';
CLUSTERING                               : 'CLUSTERING';
COLLATE                                  : 'COLLATE';
COLLECTION                               : 'COLLECTION';
COLUMN                                   : 'COLUMN';
COLUMN_ENCRYPTION_KEY                    : 'COLUMN_ENCRYPTION_KEY';
COLUMN_MASTER_KEY                        : 'COLUMN_MASTER_KEY';
COLUMNS                                  : 'COLUMNS';
COLUMNSTORE                              : 'COLUMNSTORE';
COLUMNSTORE_ARCHIVE                      : 'COLUMNSTORE_ARCHIVE';
COMMENT                                  : 'COMMENT';
COMMIT                                   : 'COMMIT';
COMMITTED                                : 'COMMITTED';
COMPATIBILITY_LEVEL                      : 'COMPATIBILITY_LEVEL';
COMPRESS_ALL_ROW_GROUPS                  : 'COMPRESS_ALL_ROW_GROUPS';
COMPRESSION                              : 'COMPRESSION';
COMPRESSION_DELAY                        : 'COMPRESSION_DELAY';
COMPUTE                                  : 'COMPUTE';
CONCAT                                   : 'CONCAT';
CONCAT_NULL_YIELDS_NULL                  : 'CONCAT_NULL_YIELDS_NULL';
CONDITION                                : 'CONDITION';
CONFIGURATION                            : 'CONFIGURATION';
CONNECT                                  : 'CONNECT';
CONNECTION                               : 'CONNECTION';
CONNECTIONS                              : 'CONNECTIONS';
CONSTRAINT                               : 'CONSTRAINT';
CONTAINMENT                              : 'CONTAINMENT';
CONTAINS                                 : 'CONTAINS';
CONTAINSTABLE                            : 'CONTAINSTABLE';
CONTENT                                  : 'CONTENT';
CONTEXT                                  : 'CONTEXT';
CONTEXT_HEADERS                          : 'CONTEXT_HEADERS';
CONTINUE                                 : 'CONTINUE';
CONTINUE_AFTER_ERROR                     : 'CONTINUE_AFTER_ERROR';
CONTRACT                                 : 'CONTRACT';
CONTRACT_NAME                            : 'CONTRACT_NAME';
CONTROL                                  : 'CONTROL';
CONVERSATION                             : 'CONVERSATION';
COOKIE                                   : 'COOKIE';
COPY                                     : 'COPY';
COPY_ONLY                                : 'COPY_ONLY';
COPY_OPTIONS_                            : 'COPY_OPTIONS';
COUNTER                                  : 'COUNTER';
CPU                                      : 'CPU';
CREATE                                   : 'CREATE';
CREATE_NEW                               : 'CREATE_NEW';
CREATION_DISPOSITION                     : 'CREATION_DISPOSITION';
CREDENTIAL                               : 'CREDENTIAL';
CREDENTIALS                              : 'CREDENTIALS';
CREDIT_QUOTA                             : 'CREDIT_QUOTA';
CROSS                                    : 'CROSS';
CRYPTOGRAPHIC                            : 'CRYPTOGRAPHIC';
CSV                                      : 'CSV';
CURRENT                                  : 'CURRENT';
CURRENT_DATE                             : 'CURRENT_DATE';
CURRENT_TIME                             : 'CURRENT_TIME';
CURRENT_TIMESTAMP                        : 'CURRENT_TIMESTAMP';
CURSOR                                   : 'CURSOR';
CURSOR_CLOSE_ON_COMMIT                   : 'CURSOR_CLOSE_ON_COMMIT';
CURSOR_DEFAULT                           : 'CURSOR_DEFAULT';
CUSTOM                                   : 'CUSTOM';
CYCLE                                    : 'CYCLE';
DAILY                                    : 'DAILY';
DATA                                     : 'DATA';
DATA_COMPRESSION                         : 'DATA_COMPRESSION';
DATA_PURITY                              : 'DATA_PURITY';
DATA_RETENTION_TIME_IN_DAYS              : 'DATA_RETENTION_TIME_IN_DAYS';
DATA_SOURCE                              : 'DATA_SOURCE';
DATABASE                                 : 'DATABASE';
DATABASE_MIRRORING                       : 'DATABASE_MIRRORING';
DATABASES                                : 'DATABASES';
DATASPACE                                : 'DATASPACE';
DATE_CORRELATION_OPTIMIZATION            : 'DATE_CORRELATION_OPTIMIZATION';
DATE_FORMAT                              : 'DATE_FORMAT';
DATE_INPUT_FORMAT                        : 'DATE_INPUT_FORMAT';
DATE_OUTPUT_FORMAT                       : 'DATE_OUTPUT_FORMAT';
DAYS                                     : 'DAYS';
DAYS_TO_EXPIRY                           : 'DAYS_TO_EXPIRY';
DB_CHAINING                              : 'DB_CHAINING';
DB_FAILOVER                              : 'DB_FAILOVER';
DBCC                                     : 'DBCC';
DBREINDEX                                : 'DBREINDEX';
DDL                                      : 'DDL';
DEALLOCATE                               : 'DEALLOCATE';
DECLARE                                  : 'DECLARE';
DECRYPTION                               : 'DECRYPTION';
DEFAULT                                  : 'DEFAULT';
DEFAULT_DATABASE                         : 'DEFAULT_DATABASE';
DEFAULT_DDL_COLLATION_                   : 'DEFAULT_DDL_COLLATION';
DEFAULT_DOUBLE_QUOTE                     : ["]'DEFAULT' ["];
DEFAULT_FULLTEXT_LANGUAGE                : 'DEFAULT_FULLTEXT_LANGUAGE';
DEFAULT_LANGUAGE                         : 'DEFAULT_LANGUAGE';
DEFAULT_NAMESPACE                        : 'DEFAULT_NAMESPACE';
DEFAULT_ROLE                             : 'DEFAULT_ROLE';
DEFAULT_SCHEMA                           : 'DEFAULT_SCHEMA';
DEFAULT_WAREHOUSE                        : 'DEFAULT_WAREHOUSE';
DEFERRABLE                               : 'DEFERRABLE';
DEFERRED                                 : 'DEFERRED';
DEFINE                                   : 'DEFINE';
DEFINITION                               : 'DEFINITION';
DEFLATE                                  : 'DEFLATE';
DELAY                                    : 'DELAY';
DELAYED_DURABILITY                       : 'DELAYED_DURABILITY';
DELEGATED                                : 'DELEGATED';
DELETE                                   : 'DELETE';
DELETED                                  : 'DELETED';
DELTA                                    : 'DELTA';
DENSE_RANK                               : 'DENSE_RANK';
DENY                                     : 'DENY';
DEPENDENTS                               : 'DEPENDENTS';
DES                                      : 'DES';
DESC                                     : 'DESC';
DESCRIBE                                 : 'DESC' 'RIBE'?;
DESCRIPTION                              : 'DESCRIPTION';
DESX                                     : 'DESX';
DETERMINISTIC                            : 'DETERMINISTIC';
DHCP                                     : 'DHCP';
DIAGNOSTICS                              : 'DIAGNOSTICS';
DIALOG                                   : 'DIALOG';
DIFFERENTIAL                             : 'DIFFERENTIAL';
DIRECTION                                : 'DIRECTION';
DIRECTORY                                : 'DIRECTORY';
DIRECTORY_NAME                           : 'DIRECTORY_NAME';
DISABLE                                  : 'DISABLE';
DISABLE_AUTO_CONVERT                     : 'DISABLE_AUTO_CONVERT';
DISABLE_BROKER                           : 'DISABLE_BROKER';
DISABLE_SNOWFLAKE_DATA                   : 'DISABLE_SNOWFLAKE_DATA';
DISABLED                                 : 'DISABLED';
DISPLAY_NAME                             : 'DISPLAY_NAME';
DISTINCT                                 : 'DISTINCT';
DISTRIBUTED                              : 'DISTRIBUTED';
DISTRIBUTION                             : 'DISTRIBUTION';
DO                                       : 'DO';
DOCUMENT                                 : 'DOCUMENT';
DOLLAR_PARTITION                         : '$PARTITION';
DOUBLE_BACK_SLASH                        : '\\\\';
DOUBLE_FORWARD_SLASH                     : '//';
DOWNSTREAM                               : 'DOWNSTREAM';
DROP                                     : 'DROP';
DROP_EXISTING                            : 'DROP_EXISTING';
DROPCLEANBUFFERS                         : 'DROPCLEANBUFFERS';
DTC_SUPPORT                              : 'DTC_SUPPORT';
DYNAMIC                                  : 'DYNAMIC';
ECONOMY                                  : 'ECONOMY';
EDGE                                     : 'EDGE';
EDITION                                  : 'EDITION';
ELEMENTS                                 : 'ELEMENTS';
ELSE                                     : 'ELSE';
EMAIL                                    : 'EMAIL';
EMERGENCY                                : 'EMERGENCY';
EMPTY                                    : 'EMPTY';
EMPTY_FIELD_AS_NULL                      : 'EMPTY_FIELD_AS_NULL';
ENABLE                                   : 'ENABLE';
ENABLE_BROKER                            : 'ENABLE_BROKER';
ENABLE_FOR_PRIVILEGE                     : 'ENABLE_FOR_PRIVILEGE';
ENABLE_INTERNAL_STAGES_PRIVATELINK       : 'ENABLE_INTERNAL_STAGES_PRIVATELINK';
ENABLE_OCTAL                             : 'ENABLE_OCTAL';
ENABLE_QUERY_ACCELERATION                : 'ENABLE_QUERY_ACCELERATION';
ENABLE_UNLOAD_PHYSICAL_TYPE_OPTIMIZATION : 'ENABLE_UNLOAD_PHYSICAL_TYPE_OPTIMIZATION';
ENABLED                                  : 'ENABLED';
ENCODING                                 : 'ENCODING';
ENCRYPTED                                : 'ENCRYPTED';
ENCRYPTED_VALUE                          : 'ENCRYPTED_VALUE';
ENCRYPTION                               : 'ENCRYPTION';
ENCRYPTION_TYPE                          : 'ENCRYPTION_TYPE';
END                                      : 'END';
END_TIMESTAMP                            : 'END_TIMESTAMP';
ENDPOINT                                 : 'ENDPOINT';
ENDPOINT_URL                             : 'ENDPOINT_URL';
ENFORCE_LENGTH                           : 'ENFORCE_LENGTH';
ENFORCE_SESSION_POLICY                   : 'ENFORCE_SESSION_POLICY';
ENFORCED                                 : 'ENFORCED';
ENTERPRISE                               : 'ENTERPRISE';
EQUALITY                                 : 'EQUALITY';
ERROR                                    : 'ERROR';
ERROR_BROKER_CONVERSATIONS               : 'ERROR_BROKER_CONVERSATIONS';
ERROR_INTEGRATION                        : 'ERROR_INTEGRATION';
ERROR_ON_COLUMN_COUNT_MISMATCH           : 'ERROR_ON_COLUMN_COUNT_MISMATCH';
ERROR_ON_NONDETERMINISTIC_MERGE          : 'ERROR_ON_NONDETERMINISTIC_MERGE';
ERROR_ON_NONDETERMINISTIC_UPDATE         : 'ERROR_ON_NONDETERMINISTIC_UPDATE';
ESCAPE                                   : 'ESCAPE';
ESCAPE_UNENCLOSED_FIELD                  : 'ESCAPE_UNENCLOSED_FIELD';
ESTIMATEONLY                             : 'ESTIMATEONLY';
EVENT                                    : 'EVENT';
EVENT_RETENTION_MODE                     : 'EVENT_RETENTION_MODE';
EXCEPT                                   : 'EXCEPT';
EXCEPTION                                : 'EXCEPTION';
EXCHANGE                                 : 'EXCHANGE';
EXCLUSIVE                                : 'EXCLUSIVE';
EXECUTABLE                               : 'EXECUTABLE';
EXECUTABLE_FILE                          : 'EXECUTABLE_FILE';
EXECUTE                                  : 'EXEC' 'UTE'?;
EXECUTION                                : 'EXECUTION';
EXISTS                                   : 'EXISTS';
EXPIREDATE                               : 'EXPIREDATE';
EXPIRY_DATE                              : 'EXPIRY_DATE';
EXPLAIN                                  : 'EXPLAIN';
EXPLICIT                                 : 'EXPLICIT';
EXTENDED_LOGICAL_CHECKS                  : 'EXTENDED_LOGICAL_CHECKS';
EXTENSION                                : 'EXTENSION';
EXTERNAL                                 : 'EXTERNAL';
EXTERNAL_ACCESS                          : 'EXTERNAL_ACCESS';
EXTRACT                                  : 'EXTRACT';
FAIL_OPERATION                           : 'FAIL_OPERATION';
FAILOVER                                 : 'FAILOVER';
FAILOVER_MODE                            : 'FAILOVER_MODE';
FAILURE                                  : 'FAILURE';
FAILURE_CONDITION_LEVEL                  : 'FAILURE_CONDITION_LEVEL';
FAILURECONDITIONLEVEL                    : 'FAILURECONDITIONLEVEL';
FALSE                                    : 'FALSE';
FAN_IN                                   : 'FAN_IN';
FAST_FORWARD                             : 'FAST_FORWARD';
FETCH                                    : 'FETCH';
FIELD_DELIMITER                          : 'FIELD_DELIMITER';
FIELD_OPTIONALLY_ENCLOSED_BY             : 'FIELD_OPTIONALLY_ENCLOSED_BY';
FILE                                     : 'FILE';
FILE_EXTENSION                           : 'FILE_EXTENSION';
FILE_FORMAT                              : 'FILE_FORMAT';
FILE_SNAPSHOT                            : 'FILE_SNAPSHOT';
FILEGROUP                                : 'FILEGROUP';
FILEGROWTH                               : 'FILEGROWTH';
FILENAME                                 : 'FILENAME';
FILEPATH                                 : 'FILEPATH';
FILES                                    : 'FILES';
FILESTREAM                               : 'FILESTREAM';
FILESTREAM_ON                            : 'FILESTREAM_ON';
FILETABLE                                : 'FILETABLE';
FILLFACTOR                               : 'FILLFACTOR';
FILTER                                   : 'FILTER';
FIRST                                    : 'FIRST';
FIRST_NAME                               : 'FIRST_NAME';
FLATTEN                                  : 'FLATTEN';
FLOOR                                    : 'FLOOR';
FMTONLY                                  : 'FMTONLY';
FOLLOWING                                : 'FOLLOWING';
FOR                                      : 'FOR';
FORCE                                    : 'FORCE';
FORCE_FAILOVER_ALLOW_DATA_LOSS           : 'FORCE_FAILOVER_ALLOW_DATA_LOSS';
FORCE_SERVICE_ALLOW_DATA_LOSS            : 'FORCE_SERVICE_ALLOW_DATA_LOSS';
FORCEPLAN                                : 'FORCEPLAN';
FORCESCAN                                : 'FORCESCAN';
FORCESEEK                                : 'FORCESEEK';
FOREIGN                                  : 'FOREIGN';
FORMAT                                   : 'FORMAT';
FORMAT_NAME                              : 'FORMAT_NAME';
FORMATS                                  : 'FORMATS';
FORWARD_ONLY                             : 'FORWARD_ONLY';
FREE                                     : 'FREE';
FREETEXT                                 : 'FREETEXT';
FREETEXTTABLE                            : 'FREETEXTTABLE';
FREQUENCY                                : 'FREQUENCY';
FROM                                     : 'FROM';
FULL                                     : 'FULL';
FULLSCAN                                 : 'FULLSCAN';
FULLTEXT                                 : 'FULLTEXT';
FUNCTION                                 : 'FUNCTION';
FUNCTIONS                                : 'FUNCTIONS';
FUTURE                                   : 'FUTURE';
GB                                       : 'GB';
GCP_PUBSUB                               : 'GCP_PUBSUB';
GCP_PUBSUB_SUBSCRIPTION_NAME             : 'GCP_PUBSUB_SUBSCRIPTION_NAME';
GCP_PUBSUB_TOPIC_NAME                    : 'GCP_PUBSUB_TOPIC_NAME';
GENERATED                                : 'GENERATED';
GEO                                      : 'GEO';
GEOGRAPHY_OUTPUT_FORMAT                  : 'GEOGRAPHY_OUTPUT_FORMAT';
GEOMETRY_OUTPUT_FORMAT                   : 'GEOMETRY_OUTPUT_FORMAT';
GET                                      : 'GET';
GETDATE                                  : 'GETDATE';
GETROOT                                  : 'GETROOT';
GLOBAL                                   : 'GLOBAL';
GO                                       : 'GO';
GOOGLE_AUDIENCE                          : 'GOOGLE_AUDIENCE';
GOTO                                     : 'GOTO';
GOVERNOR                                 : 'GOVERNOR';
GRANT                                    : 'GRANT';
GRANTS                                   : 'GRANTS';
GROUP                                    : 'GROUP';
GROUP_MAX_REQUESTS                       : 'GROUP_MAX_REQUESTS';
GROUPING                                 : 'GROUPING';
GROUPS                                   : 'GROUPS';
GZIP                                     : 'GZIP';
HADR                                     : 'HADR';
HANDLER                                  : 'HANDLER';
HASH                                     : 'HASH';
HASHED                                   : 'HASHED';
HAVING                                   : 'HAVING';
HEADER                                   : 'HEADER';
HEADERS                                  : 'HEADERS';
HEALTH_CHECK_TIMEOUT                     : 'HEALTH_CHECK_TIMEOUT';
HEALTHCHECKTIMEOUT                       : 'HEALTHCHECKTIMEOUT';
HEAP                                     : 'HEAP';
HIDDEN_KEYWORD                           : 'HIDDEN';
HIERARCHYID                              : 'HIERARCHYID';
HIGH                                     : 'HIGH';
HISTORY                                  : 'HISTORY';
HOLDLOCK                                 : 'HOLDLOCK';
HONOR_BROKER_PRIORITY                    : 'HONOR_BROKER_PRIORITY';
HOURS                                    : 'HOURS';
IDENTIFIER                               : 'IDENTIFIER';
IDENTITY                                 : 'IDENTITY';
IDENTITY_INSERT                          : 'IDENTITY_INSERT';
IDENTITY_VALUE                           : 'IDENTITY_VALUE';
IF                                       : 'IF';
IFF                                      : 'IFF';
IGNORE                                   : 'IGNORE';
IGNORE_CONSTRAINTS                       : 'IGNORE_CONSTRAINTS';
IGNORE_DUP_KEY                           : 'IGNORE_DUP_KEY';
IGNORE_REPLICATED_TABLE_CACHE            : 'IGNORE_REPLICATED_TABLE_CACHE';
IGNORE_TRIGGERS                          : 'IGNORE_TRIGGERS';
IGNORE_UTF8_ERRORS                       : 'IGNORE_UTF8_ERRORS';
IIF                                      : 'IIF';
ILIKE                                    : 'ILIKE';
IMMEDIATE                                : 'IMMEDIATE';
IMMEDIATELY                              : 'IMMEDIATELY';
IMMUTABLE                                : 'IMMUTABLE';
IMPERSONATE                              : 'IMPERSONATE';
IMPLICIT                                 : 'IMPLICIT';
IMPLICIT_TRANSACTIONS                    : 'IMPLICIT_TRANSACTIONS';
IMPORT                                   : 'IMPORT';
IMPORTANCE                               : 'IMPORTANCE';
IMPORTED                                 : 'IMPORTED';
IMPORTS                                  : 'IMPORTS';
IN                                       : 'IN';
INCLUDE                                  : 'INCLUDE';
INCLUDE_NULL_VALUES                      : 'INCLUDE_NULL_VALUES';
INCREMENT                                : 'INCREMENT';
INCREMENTAL                              : 'INCREMENTAL';
INDEX                                    : 'INDEX';
INFINITE                                 : 'INFINITE';
INFORMATION                              : 'INFORMATION';
INIT                                     : 'INIT';
INITIAL_REPLICATION_SIZE_LIMIT_IN_TB     : 'INITIAL_REPLICATION_SIZE_LIMIT_IN_TB';
INITIALLY                                : 'INITIALLY';
INITIALLY_SUSPENDED                      : 'INITIALLY_SUSPENDED';
INITIATOR                                : 'INITIATOR';
INNER                                    : 'INNER';
INPUT                                    : 'INPUT';
INSENSITIVE                              : 'INSENSITIVE';
INSERT                                   : 'INSERT';
INSERT_ONLY                              : 'INSERT_ONLY';
INSERTED                                 : 'INSERTED';
INSTEAD                                  : 'INSTEAD';
INTEGRATION                              : 'INTEGRATION';
INTEGRATIONS                             : 'INTEGRATIONS';
INTERSECT                                : 'INTERSECT';
INTERVAL                                 : 'INTERVAL';
INTO                                     : 'INTO';
IO                                       : 'IO';
IP                                       : 'IP';
IS                                       : 'IS';
ISOLATION                                : 'ISOLATION';
JDBC_TREAT_DECIMAL_AS_INT                : 'JDBC_TREAT_DECIMAL_AS_INT';
JDBC_TREAT_TIMESTAMP_NTZ_AS_UTC          : 'JDBC_TREAT_TIMESTAMP_NTZ_AS_UTC';
JDBC_USE_SESSION_TIMEZONE                : 'JDBC_USE_SESSION_TIMEZONE';
JOB                                      : 'JOB';
JOIN                                     : 'JOIN';
JS_TREAT_INTEGER_AS_BIGINT               : 'JS_TREAT_INTEGER_AS_BIGINT';
JSON                                     : 'JSON';
JSON_ARRAY                               : 'JSON_ARRAY';
JSON_INDENT                              : 'JSON_INDENT';
JSON_OBJECT                              : 'JSON_OBJECT';
KB                                       : 'KB';
KEEPDEFAULTS                             : 'KEEPDEFAULTS';
KEEPIDENTITY                             : 'KEEPIDENTITY';
KERBEROS                                 : 'KERBEROS';
KEY                                      : 'KEY';
KEY_PATH                                 : 'KEY_PATH';
KEY_SOURCE                               : 'KEY_SOURCE';
KEY_STORE_PROVIDER_NAME                  : 'KEY_STORE_PROVIDER_NAME';
KEYS                                     : 'KEYS';
KEYSET                                   : 'KEYSET';
KILL                                     : 'KILL';
KMS_KEY_ID                               : 'KMS_KEY_ID';
KWSKIP                                   : 'SKIP';
LANGUAGE                                 : 'LANGUAGE';
LARGE                                    : 'LARGE';
LAST                                     : 'LAST';
LAST_NAME                                : 'LAST_NAME';
LAST_QUERY_ID                            : 'LAST_QUERY_ID';
LATERAL                                  : 'LATERAL';
LEAD                                     : 'LEAD';
LEFT                                     : 'LEFT';
LENGTH                                   : 'LENGTH';
LET                                      : 'LET';
LEVEL                                    : 'LEVEL';
LIBRARY                                  : 'LIBRARY';
LIFETIME                                 : 'LIFETIME';
LIKE                                     : 'LIKE';
LIMIT                                    : 'LIMIT';
LINEAR                                   : 'LINEAR';
LINKED                                   : 'LINKED';
LINUX                                    : 'LINUX';
LIST                                     : 'LIST';
LISTAGG                                  : 'LISTAGG';
LISTENER                                 : 'LISTENER';
LISTENER_IP                              : 'LISTENER_IP';
LISTENER_PORT                            : 'LISTENER_PORT';
LISTENER_URL                             : 'LISTENER_URL';
LISTING                                  : 'LISTING';
LOB_COMPACTION                           : 'LOB_COMPACTION';
LOCAL                                    : 'LOCAL';
LOCAL_SERVICE_NAME                       : 'LOCAL_SERVICE_NAME';
LOCALTIME                                : 'LOCALTIME';
LOCALTIMESTAMP                           : 'LOCALTIMESTAMP';
LOCATION                                 : 'LOCATION';
LOCK                                     : 'LOCK';
LOCK_ESCALATION                          : 'LOCK_ESCALATION';
LOCK_TIMEOUT                             : 'LOCK_TIMEOUT';
LOCKS                                    : 'LOCKS';
LOGIN                                    : 'LOGIN';
LOGIN_NAME                               : 'LOGIN_NAME';
LOOKER                                   : 'LOOKER';
LOOP                                     : 'LOOP';
LOW                                      : 'LOW';
LZO                                      : 'LZO';
MANAGE                                   : 'MANAGE';
MANAGED                                  : 'MANAGED';
MANUAL                                   : 'MANUAL';
MARK                                     : 'MARK';
MASK                                     : 'MASK';
MASKED                                   : 'MASKED';
MASKING                                  : 'MASKING';
MASTER                                   : 'MASTER';
MASTER_KEY                               : 'MASTER_KEY';
MATCH                                    : 'MATCH';
MATCH_BY_COLUMN_NAME                     : 'MATCH_BY_COLUMN_NAME';
MATCH_RECOGNIZE                          : 'MATCH_RECOGNIZE';
MATCHED                                  : 'MATCHED';
MATCHES                                  : 'MATCHES';
MATERIALIZED                             : 'MATERIALIZED';
MAX                                      : 'MAX';
MAX_BATCH_ROWS                           : 'MAX_BATCH_ROWS';
MAX_CLUSTER_COUNT                        : 'MAX_CLUSTER_COUNT';
MAX_CONCURRENCY_LEVEL                    : 'MAX_CONCURRENCY_LEVEL';
MAX_CPU_PERCENT                          : 'MAX_CPU_PERCENT';
MAX_DATA_EXTENSION_TIME_IN_DAYS          : 'MAX_DATA_EXTENSION_TIME_IN_DAYS';
MAX_DISPATCH_LATENCY                     : 'MAX_DISPATCH_LATENCY';
MAX_DOP                                  : 'MAX_DOP';
MAX_DURATION                             : 'MAX_DURATION';
MAX_EVENT_SIZE                           : 'MAX_EVENT_SIZE';
MAX_FILES                                : 'MAX_FILES';
MAX_IOPS_PER_VOLUME                      : 'MAX_IOPS_PER_VOLUME';
MAX_MEMORY                               : 'MAX_MEMORY';
MAX_MEMORY_PERCENT                       : 'MAX_MEMORY_PERCENT';
MAX_OUTSTANDING_IO_PER_VOLUME            : 'MAX_OUTSTANDING_IO_PER_VOLUME';
MAX_PROCESSES                            : 'MAX_PROCESSES';
MAX_QUEUE_READERS                        : 'MAX_QUEUE_READERS';
MAX_ROLLOVER_FILES                       : 'MAX_ROLLOVER_FILES';
MAX_SIZE                                 : 'MAX_SIZE';
MAXSIZE                                  : 'MAXSIZE';
MAXTRANSFER                              : 'MAXTRANSFER';
MAXVALUE                                 : 'MAXVALUE';
MB                                       : 'MB';
MEASURES                                 : 'MEASURES';
MEDIADESCRIPTION                         : 'MEDIADESCRIPTION';
MEDIANAME                                : 'MEDIANAME';
MEDIUM                                   : 'MEDIUM';
MEMBER                                   : 'MEMBER';
MEMOIZABLE                               : 'MEMOIZABLE';
MEMORY_OPTIMIZED_DATA                    : 'MEMORY_OPTIMIZED_DATA';
MEMORY_PARTITION_MODE                    : 'MEMORY_PARTITION_MODE';
MERGE                                    : 'MERGE';
MESSAGE                                  : 'MESSAGE';
MESSAGE_FORWARD_SIZE                     : 'MESSAGE_FORWARD_SIZE';
MESSAGE_FORWARDING                       : 'MESSAGE_FORWARDING';
MIDDLE_NAME                              : 'MIDDLE_NAME';
MIN_CLUSTER_COUNT                        : 'MIN_CLUSTER_COUNT';
MIN_CPU_PERCENT                          : 'MIN_CPU_PERCENT';
MIN_DATA_RETENTION_TIME_IN_DAYS          : 'MIN_DATA_RETENTION_TIME_IN_DAYS';
MIN_IOPS_PER_VOLUME                      : 'MIN_IOPS_PER_VOLUME';
MIN_MEMORY_PERCENT                       : 'MIN_MEMORY_PERCENT';
MINS_TO_BYPASS_MFA                       : 'MINS_TO_BYPASS_MFA';
MINS_TO_UNLOCK                           : 'MINS_TO_UNLOCK';
MINUS_                                   : 'MINUS';
MINUTES                                  : 'MINUTES';
MINVALUE                                 : 'MINVALUE';
MIRROR                                   : 'MIRROR';
MIRROR_ADDRESS                           : 'MIRROR_ADDRESS';
MIXED_PAGE_ALLOCATION                    : 'MIXED_PAGE_ALLOCATION';
MODE                                     : 'MODE';
MODIFIED_AFTER                           : 'MODIFIED_AFTER';
MODIFY                                   : 'MODIFY';
MONITOR                                  : 'MONITOR';
MONITORS                                 : 'MONITORS';
MONTHLY                                  : 'MONTHLY';
MOVE                                     : 'MOVE';
MULTI_STATEMENT_COUNT                    : 'MULTI_STATEMENT_COUNT';
MULTI_USER                               : 'MULTI_USER';
MUST_CHANGE                              : 'MUST_CHANGE';
MUST_CHANGE_PASSWORD                     : 'MUST_CHANGE_PASSWORD';
NAME                                     : 'NAME';
NATURAL                                  : 'NATURAL';
NEGOTIATE                                : 'NEGOTIATE';
NESTED_TRIGGERS                          : 'NESTED_TRIGGERS';
NETWORK                                  : 'NETWORK';
NETWORK_POLICY                           : 'NETWORK_POLICY';
NEVER                                    : 'NEVER';
NEW_ACCOUNT                              : 'NEW_ACCOUNT';
NEW_BROKER                               : 'NEW_BROKER';
NEW_PASSWORD                             : 'NEW_PASSWORD';
NEWNAME                                  : 'NEWNAME';
NEXT                                     : 'NEXT';
NEXTVAL                                  : 'NEXTVAL';
NO                                       : 'NO';
NO_CHECKSUM                              : 'NO_CHECKSUM';
NO_COMPRESSION                           : 'NO_COMPRESSION';
NO_EVENT_LOSS                            : 'NO_EVENT_LOSS';
NO_INFOMSGS                              : 'NO_INFOMSGS';
NO_QUERYSTORE                            : 'NO_QUERYSTORE';
NO_STATISTICS                            : 'NO_STATISTICS';
NO_TRUNCATE                              : 'NO_TRUNCATE';
NO_WAIT                                  : 'NO_WAIT';
NOCHECK                                  : 'NOCHECK';
NOCOUNT                                  : 'NOCOUNT';
NODE                                     : 'NODE';
NODES                                    : 'NODES';
NOEXEC                                   : 'NOEXEC';
NOEXPAND                                 : 'NOEXPAND';
NOFORMAT                                 : 'NOFORMAT';
NOHOLDLOCK                               : 'NOHOLDLOCK';
NOINDEX                                  : 'NOINDEX';
NOINIT                                   : 'NOINIT';
NOLOCK                                   : 'NOLOCK';
NON_TRANSACTED_ACCESS                    : 'NON_TRANSACTED_ACCESS';
NONCLUSTERED                             : 'NONCLUSTERED';
NONE                                     : 'NONE';
NOORDER                                  : 'NOORDER';
NORECOMPUTE                              : 'NORECOMPUTE';
NORECOVERY                               : 'NORECOVERY';
NORELY                                   : 'NORELY';
NOREWIND                                 : 'NOREWIND';
NOSKIP                                   : 'NOSKIP';
NOT                                      : 'NOT';
NOTIFICATION                             : 'NOTIFICATION';
NOTIFICATION_INTEGRATION                 : 'NOTIFICATION_INTEGRATION';
NOTIFICATION_PROVIDER                    : 'NOTIFICATION_PROVIDER';
NOTIFICATIONS                            : 'NOTIFICATIONS';
NOTIFY                                   : 'NOTIFY';
NOTIFY_USERS                             : 'NOTIFY_USERS';
NOUNLOAD                                 : 'NOUNLOAD';
NOVALIDATE                               : 'NOVALIDATE';
NTILE                                    : 'NTILE';
NTLM                                     : 'NTLM';
NULL                                     : 'NULL';
NULL_IF                                  : 'NULL_IF';
NULLS                                    : 'NULLS';
NUMANODE                                 : 'NUMANODE';
NUMERIC_ROUNDABORT                       : 'NUMERIC_ROUNDABORT';
OAUTH                                    : 'OAUTH';
OAUTH_ALLOW_NON_TLS_REDIRECT_URI         : 'OAUTH_ALLOW_NON_TLS_REDIRECT_URI';
OAUTH_CLIENT                             : 'OAUTH_CLIENT';
OAUTH_CLIENT_RSA_PUBLIC_KEY              : 'OAUTH_CLIENT_RSA_PUBLIC_KEY';
OAUTH_CLIENT_RSA_PUBLIC_KEY_2            : 'OAUTH_CLIENT_RSA_PUBLIC_KEY_2';
OAUTH_ENFORCE_PKCE                       : 'OAUTH_ENFORCE_PKCE';
OAUTH_ISSUE_REFRESH_TOKENS               : 'OAUTH_ISSUE_REFRESH_TOKENS';
OAUTH_REDIRECT_URI                       : 'OAUTH_REDIRECT_URI';
OAUTH_REFRESH_TOKEN_VALIDITY             : 'OAUTH_REFRESH_TOKEN_VALIDITY';
OAUTH_USE_SECONDARY_ROLES                : 'OAUTH_USE_SECONDARY_ROLES';
OBJECT                                   : 'OBJECT';
OBJECT_TYPES                             : 'OBJECT_TYPES';
OBJECTS                                  : 'OBJECTS';
OF                                       : 'OF';
OFF                                      : 'OFF';
OFFLINE                                  : 'OFFLINE';
OFFSET                                   : 'OFFSET';
OKTA                                     : 'OKTA';
OLD                                      : 'OLD';
OLD_ACCOUNT                              : 'OLD_ACCOUNT';
OLD_PASSWORD                             : 'OLD_PASSWORD';
OMIT                                     : 'OMIT';
ON                                       : 'ON';
ON_ERROR                                 : 'ON_ERROR';
ON_FAILURE                               : 'ON_FAILURE';
ONE                                      : 'ONE';
ONLINE                                   : 'ONLINE';
ONLY                                     : 'ONLY';
OPEN                                     : 'OPEN';
OPEN_EXISTING                            : 'OPEN_EXISTING';
OPENDATASOURCE                           : 'OPENDATASOURCE';
OPENJSON                                 : 'OPENJSON';
OPENQUERY                                : 'OPENQUERY';
OPENROWSET                               : 'OPENROWSET';
OPENXML                                  : 'OPENXML';
OPERATE                                  : 'OPERATE';
OPERATIONS                               : 'OPERATIONS';
OPTIMISTIC                               : 'OPTIMISTIC';
OPTIMIZATION                             : 'OPTIMIZATION';
OPTION                                   : 'OPTION';
OR                                       : 'OR';
ORC                                      : 'ORC';
ORDER                                    : 'ORDER';
ORGADMIN                                 : 'ORGADMIN';
ORGANIZATION                             : 'ORGANIZATION';
OUT                                      : 'OUT';
OUTBOUND                                 : 'OUTBOUND';
OUTER                                    : 'OUTER';
OUTPUT                                   : 'OUTPUT';
OVER                                     : 'OVER';
OVERRIDE                                 : 'OVERRIDE';
OVERWRITE                                : 'OVERWRITE';
OWNER                                    : 'OWNER';
OWNERSHIP                                : 'OWNERSHIP';
PACKAGES                                 : 'PACKAGES';
PAD_INDEX                                : 'PAD_INDEX';
PAGE                                     : 'PAGE';
PAGE_VERIFY                              : 'PAGE_VERIFY';
PAGECOUNT                                : 'PAGECOUNT';
PAGLOCK                                  : 'PAGLOCK';
PARALLEL                                 : 'PARALLEL';
PARAM_NODE                               : 'PARAM_NODE';
PARAMETERIZATION                         : 'PARAMETERIZATION';
PARAMETERS                               : 'PARAMETERS';
PARQUET                                  : 'PARQUET';
PARSE                                    : 'PARSE';
PARSEONLY                                : 'PARSEONLY';
PARTIAL                                  : 'PARTIAL';
PARTITION                                : 'PARTITION';
PARTITION_TYPE                           : 'PARTITION_TYPE';
PARTITIONS                               : 'PARTITIONS';
PARTNER                                  : 'PARTNER';
PASSWORD                                 : 'PASSWORD';
PAST                                     : 'PAST';
PATH                                     : 'PATH';
PATTERN                                  : 'PATTERN';
PAUSE                                    : 'PAUSE';
PDW_SHOWSPACEUSED                        : 'PDW_SHOWSPACEUSED';
PER                                      : 'PER';
PER_CPU                                  : 'PER_CPU';
PER_DB                                   : 'PER_DB';
PER_NODE                                 : 'PER_NODE';
PERCENT                                  : 'PERCENT';
PERIODIC_DATA_REKEYING                   : 'PERIODIC_DATA_REKEYING';
PERMISSION_SET                           : 'PERMISSION_SET';
PERSIST_SAMPLE_PERCENT                   : 'PERSIST_SAMPLE_PERCENT';
PERSISTED                                : 'PERSISTED';
PHYSICAL_ONLY                            : 'PHYSICAL_ONLY';
PING_FEDERATE                            : 'PING_FEDERATE';
PIPE                                     : 'PIPE';
PIPE_EXECUTION_PAUSED                    : 'PIPE_EXECUTION_PAUSED';
PIPES                                    : 'PIPES';
PIVOT                                    : 'PIVOT';
PLATFORM                                 : 'PLATFORM';
POISON_MESSAGE_HANDLING                  : 'POISON_MESSAGE_HANDLING';
POLICIES                                 : 'POLICIES';
POLICY                                   : 'POLICY';
POOL                                     : 'POOL';
PORT                                     : 'PORT';
PRE_AUTHORIZED_ROLES_LIST                : 'PRE_AUTHORIZED_ROLES_LIST';
PRECEDING                                : 'PRECEDING';
PREDICATE                                : 'PREDICATE';
PREFIX                                   : 'PREFIX';
PRESERVE_SPACE                           : 'PRESERVE_SPACE';
PREVENT_UNLOAD_TO_INLINE_URL             : 'PREVENT_UNLOAD_TO_INLINE_URL';
PREVENT_UNLOAD_TO_INTERNAL_STAGES        : 'PREVENT_UNLOAD_TO_INTERNAL_STAGES';
PRIMARY                                  : 'PRIMARY';
PRIMARY_ROLE                             : 'PRIMARY_ROLE';
PRINT                                    : 'PRINT';
PRIOR                                    : 'PRIOR';
PRIORITY                                 : 'PRIORITY';
PRIORITY_LEVEL                           : 'PRIORITY_LEVEL';
PRIVATE                                  : 'PRIVATE';
PRIVATE_KEY                              : 'PRIVATE_KEY';
PRIVILEGES                               : 'PRIVILEGES';
PROCCACHE                                : 'PROCCACHE';
PROCEDURE                                : 'PROC' 'EDURE'?;
PROCEDURE_NAME                           : 'PROCEDURE_NAME';
PROCEDURES                               : 'PROCEDURES';
PROCESS                                  : 'PROCESS';
PROFILE                                  : 'PROFILE';
PROPERTY                                 : 'PROPERTY';
PROVIDER                                 : 'PROVIDER';
PROVIDER_KEY_NAME                        : 'PROVIDER_KEY_NAME';
PUBLIC                                   : 'PUBLIC';
PURGE                                    : 'PURGE';
PUT                                      : 'PUT';
QUALIFY                                  : 'QUALIFY';
QUERIES                                  : 'QUERIES';
QUERY                                    : 'QUERY';
QUERY_ACCELERATION_MAX_SCALE_FACTOR      : 'QUERY_ACCELERATION_MAX_SCALE_FACTOR';
QUERY_STORE                              : 'QUERY_STORE';
QUERY_TAG                                : 'QUERY_TAG';
QUEUE                                    : 'QUEUE';
QUEUE_DELAY                              : 'QUEUE_DELAY';
QUOTED_IDENTIFIER                        : 'QUOTED_IDENTIFIER';
QUOTED_IDENTIFIERS_IGNORE_CASE           : 'QUOTED_IDENTIFIERS_IGNORE_CASE';
RAISERROR                                : 'RAISERROR';
RANDOMIZED                               : 'RANDOMIZED';
RANGE                                    : 'RANGE';
RANK                                     : 'RANK';
RAW                                      : 'RAW';
RAW_DEFLATE                              : 'RAW_DEFLATE';
RC2                                      : 'RC2';
RC4                                      : 'RC4';
RC4_128                                  : 'RC4_128';
READ                                     : 'READ';
READ_COMMITTED_SNAPSHOT                  : 'READ_COMMITTED_SNAPSHOT';
READ_ONLY                                : 'READ_ONLY';
READ_ONLY_ROUTING_LIST                   : 'READ_ONLY_ROUTING_LIST';
READ_WRITE                               : 'READ_WRITE';
READ_WRITE_FILEGROUPS                    : 'READ_WRITE_FILEGROUPS';
READCOMMITTED                            : 'READCOMMITTED';
READCOMMITTEDLOCK                        : 'READCOMMITTEDLOCK';
READER                                   : 'READER';
READONLY                                 : 'READONLY';
READPAST                                 : 'READPAST';
READUNCOMMITTED                          : 'READUNCOMMITTED';
READWRITE                                : 'READWRITE';
REBUILD                                  : 'REBUILD';
RECEIVE                                  : 'RECEIVE';
RECLUSTER                                : 'RECLUSTER';
RECONFIGURE                              : 'RECONFIGURE';
RECORD_DELIMITER                         : 'RECORD_DELIMITER';
RECOVERY                                 : 'RECOVERY';
RECURSIVE                                : 'RECURSIVE';
RECURSIVE_TRIGGERS                       : 'RECURSIVE_TRIGGERS';
REFERENCE_USAGE                          : 'REFERENCE_USAGE';
REFERENCES                               : 'REFERENCES';
REFRESH                                  : 'REFRESH';
REFRESH_ON_CREATE                        : 'REFRESH_ON_CREATE';
REGENERATE                               : 'REGENERATE';
REGION                                   : 'REGION';
REGION_GROUP                             : 'REGION_GROUP';
REGIONS                                  : 'REGIONS';
RELATED_CONVERSATION                     : 'RELATED_CONVERSATION';
RELATED_CONVERSATION_GROUP               : 'RELATED_CONVERSATION_GROUP';
RELATIVE                                 : 'RELATIVE';
RELY                                     : 'RELY';
REMOTE                                   : 'REMOTE';
REMOTE_PROC_TRANSACTIONS                 : 'REMOTE_PROC_TRANSACTIONS';
REMOTE_SERVICE_NAME                      : 'REMOTE_SERVICE_NAME';
REMOVE                                   : 'REMOVE';
RENAME                                   : 'RENAME';
REORGANIZE                               : 'REORGANIZE';
REPAIR_ALLOW_DATA_LOSS                   : 'REPAIR_ALLOW_DATA_LOSS';
REPAIR_FAST                              : 'REPAIR_FAST';
REPAIR_REBUILD                           : 'REPAIR_REBUILD';
REPEATABLE                               : 'REPEATABLE';
REPEATABLEREAD                           : 'REPEATABLEREAD';
REPLACE                                  : 'REPLACE';
REPLACE_INVALID_CHARACTERS               : 'REPLACE_INVALID_CHARACTERS';
REPLICA                                  : 'REPLICA';
REPLICATE                                : 'REPLICATE';
REPLICATION                              : 'REPLICATION';
REPLICATION_SCHEDULE                     : 'REPLICATION_SCHEDULE';
REQUEST_MAX_CPU_TIME_SEC                 : 'REQUEST_MAX_CPU_TIME_SEC';
REQUEST_MAX_MEMORY_GRANT_PERCENT         : 'REQUEST_MAX_MEMORY_GRANT_PERCENT';
REQUEST_MEMORY_GRANT_TIMEOUT_SEC         : 'REQUEST_MEMORY_GRANT_TIMEOUT_SEC';
REQUEST_TRANSLATOR                       : 'REQUEST_TRANSLATOR';
REQUIRED                                 : 'REQUIRED';
RESAMPLE                                 : 'RESAMPLE';
RESERVE_DISK_SPACE                       : 'RESERVE_DISK_SPACE';
RESET                                    : 'RESET';
RESOURCE                                 : 'RESOURCE';
RESOURCE_MANAGER_LOCATION                : 'RESOURCE_MANAGER_LOCATION';
RESOURCE_MONITOR                         : 'RESOURCE_MONITOR';
RESOURCES                                : 'RESOURCES';
RESPECT                                  : 'RESPECT';
RESPONSE_TRANSLATOR                      : 'RESPONSE_TRANSLATOR';
RESTART                                  : 'RESTART';
RESTRICT                                 : 'RESTRICT';
RESTRICTED_USER                          : 'RESTRICTED_USER';
RESTRICTIONS                             : 'RESTRICTIONS';
RESULT                                   : 'RESULT';
RESULTSET                                : 'RESULTSET';
RESUMABLE                                : 'RESUMABLE';
RESUME                                   : 'RESUME';
RETAINDAYS                               : 'RETAINDAYS';
RETENTION                                : 'RETENTION';
RETURN                                   : 'RETURN';
RETURN_ALL_ERRORS                        : 'RETURN_ALL_ERRORS';
RETURN_ERRORS                            : 'RETURN_ERRORS';
RETURN_FAILED_ONLY                       : 'RETURN_FAILED_ONLY';
RETURN_ROWS                              : 'RETURN_ROWS';
RETURNS                                  : 'RETURNS';
REVERT                                   : 'REVERT';
REVOKE                                   : 'REVOKE';
REWIND                                   : 'REWIND';
RIGHT                                    : 'RIGHT';
RLIKE                                    : 'RLIKE';
ROLE                                     : 'ROLE';
ROLES                                    : 'ROLES';
ROLLBACK                                 : 'ROLLBACK';
ROOT                                     : 'ROOT';
ROUND_ROBIN                              : 'ROUND_ROBIN';
ROUTE                                    : 'ROUTE';
ROW                                      : 'ROW';
ROWCOUNT                                 : 'ROWCOUNT';
ROWGUID                                  : 'ROWGUID';
ROWGUIDCOL                               : 'ROWGUIDCOL';
ROWLOCK                                  : 'ROWLOCK';
ROWS                                     : 'ROWS';
ROWS_PER_RESULTSET                       : 'ROWS_PER_RESULTSET';
RSA_512                                  : 'RSA_512';
RSA_1024                                 : 'RSA_1024';
RSA_2048                                 : 'RSA_2048';
RSA_3072                                 : 'RSA_3072';
RSA_4096                                 : 'RSA_4096';
RSA_PUBLIC_KEY                           : 'RSA_PUBLIC_KEY';
RSA_PUBLIC_KEY_2                         : 'RSA_PUBLIC_KEY_2';
RULE                                     : 'RULE';
RUN_AS_ROLE                              : 'RUN_AS_ROLE';
RUNTIME_VERSION                          : 'RUNTIME_VERSION';
SAFE                                     : 'SAFE';
SAFETY                                   : 'SAFETY';
SAML2                                    : 'SAML2';
SAML2_ENABLE_SP_INITIATED                : 'SAML2_ENABLE_SP_INITIATED';
SAML2_FORCE_AUTHN                        : 'SAML2_FORCE_AUTHN';
SAML2_ISSUER                             : 'SAML2_ISSUER';
SAML2_POST_LOGOUT_REDIRECT_URL           : 'SAML2_POST_LOGOUT_REDIRECT_URL';
SAML2_PROVIDER                           : 'SAML2_PROVIDER';
SAML2_REQUESTED_NAMEID_FORMAT            : 'SAML2_REQUESTED_NAMEID_FORMAT';
SAML2_SIGN_REQUEST                       : 'SAML2_SIGN_REQUEST';
SAML2_SNOWFLAKE_ACS_URL                  : 'SAML2_SNOWFLAKE_ACS_URL';
SAML2_SNOWFLAKE_ISSUER_URL               : 'SAML2_SNOWFLAKE_ISSUER_URL';
SAML2_SNOWFLAKE_X509_CERT                : 'SAML2_SNOWFLAKE_X509_CERT';
SAML2_SP_INITIATED_LOGIN_PAGE_LABEL      : 'SAML2_SP_INITIATED_LOGIN_PAGE_LABEL';
SAML2_SSO_URL                            : 'SAML2_SSO_URL';
SAML2_X509_CERT                          : 'SAML2_X509_CERT';
SAML_IDENTITY_PROVIDER                   : 'SAML_IDENTITY_PROVIDER';
SAMPLE                                   : 'SAMPLE';
SAVE                                     : 'SAVE';
SAVE_OLD_URL                             : 'SAVE_OLD_URL';
SCALING_POLICY                           : 'SCALING_POLICY';
SCHEDULE                                 : 'SCHEDULE';
SCHEDULER                                : 'SCHEDULER';
SCHEMA                                   : 'SCHEMA';
SCHEMABINDING                            : 'SCHEMABINDING';
SCHEMAS                                  : 'SCHEMAS';
SCHEME                                   : 'SCHEME';
SCIM                                     : 'SCIM';
SCIM_CLIENT                              : 'SCIM_CLIENT';
SCOPED                                   : 'SCOPED';
SCRIPT                                   : 'SCRIPT';
SCROLL                                   : 'SCROLL';
SCROLL_LOCKS                             : 'SCROLL_LOCKS';
SEARCH                                   : 'SEARCH';
SECONDARY                                : 'SECONDARY';
SECONDARY_ONLY                           : 'SECONDARY_ONLY';
SECONDARY_ROLE                           : 'SECONDARY_ROLE';
SECONDS                                  : 'SECONDS';
SECRET                                   : 'SECRET';
SECURABLES                               : 'SECURABLES';
SECURE                                   : 'SECURE';
SECURITY                                 : 'SECURITY';
SECURITY_LOG                             : 'SECURITY_LOG';
SECURITYADMIN                            : 'SECURITYADMIN';
SEED                                     : 'SEED';
SEEDING_MODE                             : 'SEEDING_MODE';
SELECT                                   : 'SELECT';
SELF                                     : 'SELF';
SEMANTICKEYPHRASETABLE                   : 'SEMANTICKEYPHRASETABLE';
SEMANTICSIMILARITYDETAILSTABLE           : 'SEMANTICSIMILARITYDETAILSTABLE';
SEMANTICSIMILARITYTABLE                  : 'SEMANTICSIMILARITYTABLE';
SEMI_SENSITIVE                           : 'SEMI_SENSITIVE';
SEND                                     : 'SEND';
SENT                                     : 'SENT';
SEQUENCE                                 : 'SEQUENCE';
SEQUENCE_NUMBER                          : 'SEQUENCE_NUMBER';
SEQUENCES                                : 'SEQUENCES';
SERIALIZABLE                             : 'SERIALIZABLE';
SERVER                                   : 'SERVER';
SERVICE                                  : 'SERVICE';
SERVICE_BROKER                           : 'SERVICE_BROKER';
SERVICE_NAME                             : 'SERVICE_NAME';
SERVICEBROKER                            : 'SERVICEBROKER';
SESSION                                  : 'SESSION';
SESSION_IDLE_TIMEOUT_MINS                : 'SESSION_IDLE_TIMEOUT_MINS';
SESSION_POLICY                           : 'SESSION_POLICY';
SESSION_TIMEOUT                          : 'SESSION_TIMEOUT';
SESSION_UI_IDLE_TIMEOUT_MINS             : 'SESSION_UI_IDLE_TIMEOUT_MINS';
SESSION_USER                             : 'SESSION_USER';
SET                                      : 'SET';
SETS                                     : 'SETS';
SETTINGS                                 : 'SETTINGS';
SETUSER                                  : 'SETUSER';
SHARE                                    : 'SHARE';
SHARE_RESTRICTIONS                       : 'SHARE_RESTRICTIONS';
SHARED                                   : 'SHARED';
SHARES                                   : 'SHARES';
SHOW                                     : 'SHOW';
SHOW_INITIAL_ROWS                        : 'SHOW_INITIAL_ROWS';
SHOWCONTIG                               : 'SHOWCONTIG';
SHOWPLAN                                 : 'SHOWPLAN';
SHOWPLAN_ALL                             : 'SHOWPLAN_ALL';
SHOWPLAN_TEXT                            : 'SHOWPLAN_TEXT';
SHOWPLAN_XML                             : 'SHOWPLAN_XML';
SHRINKLOG                                : 'SHRINKLOG';
SHUTDOWN                                 : 'SHUTDOWN';
SID                                      : 'SID';
SIGNATURE                                : 'SIGNATURE';
SIMPLE                                   : 'SIMPLE';
SIMULATED_DATA_SHARING_CONSUMER          : 'SIMULATED_DATA_SHARING_CONSUMER';
SINGLE_USER                              : 'SINGLE_USER';
SIZE                                     : 'SIZE';
SIZE_LIMIT                               : 'SIZE_LIMIT';
SKIP_BLANK_LINES                         : 'SKIP_BLANK_LINES';
SKIP_BYTE_ORDER_MARK                     : 'SKIP_BYTE_ORDER_MARK';
SKIP_FILE                                : 'SKIP_FILE';
SKIP_HEADER                              : 'SKIP_HEADER';
SMALL                                    : 'SMALL';
SNAPPY                                   : 'SNAPPY';
SNAPPY_COMPRESSION                       : 'SNAPPY_COMPRESSION';
SNAPSHOT                                 : 'SNAPSHOT';
SNOWFLAKE_FULL                           : 'SNOWFLAKE_FULL';
SNOWFLAKE_SSE                            : 'SNOWFLAKE_SSE';
SOFTNUMA                                 : 'SOFTNUMA';
SOME                                     : 'SOME';
SORT_IN_TEMPDB                           : 'SORT_IN_TEMPDB';
SOURCE                                   : 'SOURCE';
SOURCE_COMPRESSION                       : 'SOURCE_COMPRESSION';
SP_EXECUTESQL                            : 'SP_EXECUTESQL';
SPARSE                                   : 'SPARSE';
SPATIAL_WINDOW_MAX_CELLS                 : 'SPATIAL_WINDOW_MAX_CELLS';
SPECIFICATION                            : 'SPECIFICATION';
SPLIT                                    : 'SPLIT';
SQLDUMPERFLAGS                           : 'SQLDUMPERFLAGS';
SQLDUMPERPATH                            : 'SQLDUMPERPATH';
SQLDUMPERTIMEOUT                         : 'SQLDUMPERTIMEOUT';
SSO_LOGIN_PAGE                           : 'SSO_LOGIN_PAGE';
STAGE                                    : 'STAGE';
STAGE_COPY_OPTIONS                       : 'STAGE_COPY_OPTIONS';
STAGE_FILE_FORMAT                        : 'STAGE_FILE_FORMAT';
STAGES                                   : 'STAGES';
STANDARD                                 : 'STANDARD';
STANDBY                                  : 'STANDBY';
START                                    : 'START';
START_DATE                               : 'START_DATE';
START_TIMESTAMP                          : 'START_TIMESTAMP';
STARTED                                  : 'STARTED';
STARTS                                   : 'STARTS';
STARTUP_STATE                            : 'STARTUP_STATE';
STATE                                    : 'STATE';
STATEMENT                                : 'STATEMENT';
STATEMENT_QUEUED_TIMEOUT_IN_SECONDS      : 'STATEMENT_QUEUED_TIMEOUT_IN_SECONDS';
STATEMENT_TIMEOUT_IN_SECONDS             : 'STATEMENT_TIMEOUT_IN_SECONDS';
STATIC                                   : 'STATIC';
STATISTICS                               : 'STATISTICS';
STATISTICS_INCREMENTAL                   : 'STATISTICS_INCREMENTAL';
STATISTICS_NORECOMPUTE                   : 'STATISTICS_NORECOMPUTE';
STATS                                    : 'STATS';
STATS_STREAM                             : 'STATS_STREAM';
STATUS                                   : 'STATUS';
STATUSONLY                               : 'STATUSONLY';
STOP                                     : 'STOP';
STOP_ON_ERROR                            : 'STOP_ON_ERROR';
STOPLIST                                 : 'STOPLIST';
STOPPED                                  : 'STOPPED';
STORAGE                                  : 'STORAGE';
STORAGE_ALLOWED_LOCATIONS                : 'STORAGE_ALLOWED_LOCATIONS';
STORAGE_AWS_OBJECT_ACL                   : 'STORAGE_AWS_OBJECT_ACL';
STORAGE_AWS_ROLE_ARN                     : 'STORAGE_AWS_ROLE_ARN';
STORAGE_BLOCKED_LOCATIONS                : 'STORAGE_BLOCKED_LOCATIONS';
STORAGE_INTEGRATION                      : 'STORAGE_INTEGRATION';
STORAGE_PROVIDER                         : 'STORAGE_PROVIDER';
STREAM                                   : 'STREAM';
STREAMS                                  : 'STREAMS';
STRICT                                   : 'STRICT';
STRICT_JSON_OUTPUT                       : 'STRICT_JSON_OUTPUT';
STRIP_NULL_VALUES                        : 'STRIP_NULL_VALUES';
STRIP_OUTER_ARRAY                        : 'STRIP_OUTER_ARRAY';
STRIP_OUTER_ELEMENT                      : 'STRIP_OUTER_ELEMENT';
SUBJECT                                  : 'SUBJECT';
SUBSCRIBE                                : 'SUBSCRIBE';
SUBSCRIPTION                             : 'SUBSCRIPTION';
SUBSTRING                                : 'SUBSTRING';
SUPPORTED                                : 'SUPPORTED';
SUSPEND                                  : 'SUSPEND';
SUSPEND_IMMEDIATE                        : 'SUSPEND_IMMEDIATE';
SUSPEND_TASK_AFTER_NUM_FAILURES          : 'SUSPEND_TASK_AFTER_NUM_FAILURES';
SUSPENDED                                : 'SUSPENDED';
SWAP                                     : 'SWAP';
SWITCH                                   : 'SWITCH';
SYMMETRIC                                : 'SYMMETRIC';
SYNC_PASSWORD                            : 'SYNC_PASSWORD';
SYNCHRONOUS_COMMIT                       : 'SYNCHRONOUS_COMMIT';
SYNONYM                                  : 'SYNONYM';
SYSADMIN                                 : 'SYSADMIN';
SYSTEM                                   : 'SYSTEM';
SYSTEM_USER                              : 'SYSTEM_USER';
TABLE                                    : 'TABLE';
TABLE_FORMAT                             : 'TABLE_FORMAT';
TABLEAU_DESKTOP                          : 'TABLEAU_DESKTOP';
TABLEAU_SERVER                           : 'TABLEAU_SERVER';
TABLERESULTS                             : 'TABLERESULTS';
TABLES                                   : 'TABLES';
TABLESAMPLE                              : 'TABLESAMPLE';
TABLOCK                                  : 'TABLOCK';
TABLOCKX                                 : 'TABLOCKX';
TABULAR                                  : 'TABULAR';
TAG                                      : 'TAG';
TAGS                                     : 'TAGS';
TAKE                                     : 'TAKE';
TAPE                                     : 'TAPE';
TARGET                                   : 'TARGET';
TARGET_LAG                               : 'TARGET_LAG';
TARGET_RECOVERY_TIME                     : 'TARGET_RECOVERY_TIME';
TASK                                     : 'TASK';
TASKS                                    : 'TASKS';
TB                                       : 'TB';
TCP                                      : 'TCP';
TEMP                                     : 'TEMP';
TEMPORARY                                : 'TEMPORARY';
TERSE                                    : 'TERSE';
TEXTIMAGE_ON                             : 'TEXTIMAGE_ON';
TEXTSIZE                                 : 'TEXTSIZE';
THEN                                     : 'THEN';
THROW                                    : 'THROW';
TIES                                     : 'TIES';
TIME_FORMAT                              : 'TIME_FORMAT';
TIME_INPUT_FORMAT                        : 'TIME_INPUT_FORMAT';
TIME_OUTPUT_FORMAT                       : 'TIME_OUTPUT_FORMAT';
TIMEDIFF                                 : 'TIMEDIFF';
TIMEOUT                                  : 'TIMEOUT';
TIMER                                    : 'TIMER';
TIMESTAMP                                : 'TIMESTAMP';
TIMESTAMP_DAY_IS_ALWAYS_24H              : 'TIMESTAMP_DAY_IS_ALWAYS_24H';
TIMESTAMP_FORMAT                         : 'TIMESTAMP_FORMAT';
TIMESTAMP_INPUT_FORMAT                   : 'TIMESTAMP_INPUT_FORMAT';
TIMESTAMP_LTZ_OUTPUT_FORMAT              : 'TIMESTAMP_LTZ_OUTPUT_FORMAT';
TIMESTAMP_NTZ_OUTPUT_FORMAT              : 'TIMESTAMP_NTZ_OUTPUT_FORMAT';
TIMESTAMP_OUTPUT_FORMAT                  : 'TIMESTAMP_OUTPUT_FORMAT';
TIMESTAMP_TYPE_MAPPING                   : 'TIMESTAMP_TYPE_MAPPING';
TIMESTAMP_TZ_OUTPUT_FORMAT               : 'TIMESTAMP_TZ_OUTPUT_FORMAT';
TIMEZONE                                 : 'TIMEZONE';
TO                                       : 'TO';
TOP                                      : 'TOP';
TORN_PAGE_DETECTION                      : 'TORN_PAGE_DETECTION';
TOSTRING                                 : 'TOSTRING';
TRACE                                    : 'TRACE';
TRACK_CAUSALITY                          : 'TRACK_CAUSALITY';
TRACKING                                 : 'TRACKING';
TRAN                                     : 'TRAN';
TRANSACTION                              : 'TRANSACTION';
TRANSACTION_ABORT_ON_ERROR               : 'TRANSACTION_ABORT_ON_ERROR';
TRANSACTION_DEFAULT_ISOLATION_LEVEL      : 'TRANSACTION_DEFAULT_ISOLATION_LEVEL';
TRANSACTION_ID                           : 'TRANSACTION_ID';
TRANSACTIONS                             : 'TRANSACTIONS';
TRANSFER                                 : 'TRANSFER';
TRANSFORM_NOISE_WORDS                    : 'TRANSFORM_NOISE_WORDS';
TRANSIENT                                : 'TRANSIENT';
TRIGGER                                  : 'TRIGGER';
TRIGGERS                                 : 'TRIGGERS';
TRIM_SPACE                               : 'TRIM_SPACE';
TRIPLE_DES                               : 'TRIPLE_DES';
TRIPLE_DES_3KEY                          : 'TRIPLE_DES_3KEY';
TRUE                                     : 'TRUE';
TRUNCATE                                 : 'TRUNCATE';
TRUNCATECOLUMNS                          : 'TRUNCATECOLUMNS';
TRUSTWORTHY                              : 'TRUSTWORTHY';
TRY                                      : 'TRY';
TRY_CAST                                 : 'TRY_CAST';
TSQL                                     : 'TSQL';
TWO_DIGIT_CENTURY_START                  : 'TWO_DIGIT_CENTURY_START';
TWO_DIGIT_YEAR_CUTOFF                    : 'TWO_DIGIT_YEAR_CUTOFF';
TYPE                                     : 'TYPE';
TYPE_WARNING                             : 'TYPE_WARNING';
UNBOUNDED                                : 'UNBOUNDED';
UNCHECKED                                : 'UNCHECKED';
UNCOMMITTED                              : 'UNCOMMITTED';
UNDROP                                   : 'UNDROP';
UNION                                    : 'UNION';
UNIQUE                                   : 'UNIQUE';
UNLIMITED                                : 'UNLIMITED';
UNLOCK                                   : 'UNLOCK';
UNMASK                                   : 'UNMASK';
UNMATCHED                                : 'UNMATCHED';
UNPIVOT                                  : 'UNPIVOT';
UNSAFE                                   : 'UNSAFE';
UNSET                                    : 'UNSET';
UNSUPPORTED_DDL_ACTION                   : 'UNSUPPORTED_DDL_ACTION';
UOW                                      : 'UOW';
UPDATE                                   : 'UPDATE';
UPDLOCK                                  : 'UPDLOCK';
URL                                      : 'URL';
USAGE                                    : 'USAGE';
USE                                      : 'USE';
USE_ANY_ROLE                             : 'USE_ANY_ROLE';
USE_CACHED_RESULT                        : 'USE_CACHED_RESULT';
USED                                     : 'USED';
USER                                     : 'USER';
USER_SPECIFIED                           : 'USER_SPECIFIED';
USER_TASK_MANAGED_INITIAL_WAREHOUSE_SIZE : 'USER_TASK_MANAGED_INITIAL_WAREHOUSE_SIZE';
USER_TASK_TIMEOUT_MS                     : 'USER_TASK_TIMEOUT_MS';
USERADMIN                                : 'USERADMIN';
USERS                                    : 'USERS';
USING                                    : 'USING';
VALID_XML                                : 'VALID_XML';
VALIDATE                                 : 'VALIDATE';
VALIDATION                               : 'VALIDATION';
VALIDATION_MODE                          : 'VALIDATION_MODE';
VALUE                                    : 'VALUE';
VALUES                                   : 'VALUES';
VAR                                      : 'VAR';
VARIABLES                                : 'VARIABLES';
VARYING                                  : 'VARYING';
VERBOSELOGGING                           : 'VERBOSELOGGING';
VERIFY_CLONEDB                           : 'VERIFY_CLONEDB';
VERSION                                  : 'VERSION';
VIEW                                     : 'VIEW';
VIEW_METADATA                            : 'VIEW_METADATA';
VIEWS                                    : 'VIEWS';
VISIBILITY                               : 'VISIBILITY';
VOLATILE                                 : 'VOLATILE';
WAIT                                     : 'WAIT';
WAIT_AT_LOW_PRIORITY                     : 'WAIT_AT_LOW_PRIORITY';
WAITFOR                                  : 'WAITFOR';
WAREHOUSE                                : 'WAREHOUSE';
WAREHOUSE_SIZE                           : 'WAREHOUSE_SIZE';
WAREHOUSE_TYPE                           : 'WAREHOUSE_TYPE';
WAREHOUSES                               : 'WAREHOUSES';
WEEK_OF_YEAR_POLICY                      : 'WEEK_OF_YEAR_POLICY';
WEEK_START                               : 'WEEK_START';
WEEKLY                                   : 'WEEKLY';
WELL_FORMED_XML                          : 'WELL_FORMED_XML';
WHEN                                     : 'WHEN';
WHERE                                    : 'WHERE';
WHILE                                    : 'WHILE';
WINDOWS                                  : 'WINDOWS';
WITH                                     : 'WITH';
WITHIN                                   : 'WITHIN';
WITHOUT                                  : 'WITHOUT';
WITHOUT_ARRAY_WRAPPER                    : 'WITHOUT_ARRAY_WRAPPER';
WITNESS                                  : 'WITNESS';
WORK                                     : 'WORK';
WORKLOAD                                 : 'WORKLOAD';
WRITE                                    : 'WRITE';
X4LARGE                                  : 'X4LARGE';
X5LARGE                                  : 'X5LARGE';
X6LARGE                                  : 'X6LARGE';
XACT_ABORT                               : 'XACT_ABORT';
XLARGE                                   : 'XLARGE';
XLOCK                                    : 'XLOCK';
XML                                      : 'XML';
XML_COMPRESSION                          : 'XML_COMPRESSION';
XMLDATA                                  : 'XMLDATA';
XMLNAMESPACES                            : 'XMLNAMESPACES';
XMLSCHEMA                                : 'XMLSCHEMA';
XSINIL                                   : 'XSINIL';
XSMALL                                   : 'XSMALL';
XXLARGE                                  : 'XXLARGE';
XXXLARGE                                 : 'XXXLARGE';
YEARLY                                   : 'YEARLY';
ZONE                                     : 'ZONE';
ZSTD                                     : 'ZSTD';

// Common operators
ASSIGN: ':=';

// Common symbols
DOLLAR_STRING: '$$' ('\\$' | '$' ~'$' | ~'$')*? '$$';

// Junky stuff for Snowflake - we will gradually get rid of this

// TODO: Revisit these tokens
RETURN_N_ROWS : 'RETURN_' [0-9]+ '_ROWS';
SKIP_FILE_N   : 'SKIP_FILE_' [0-9]+;

// TODO: Replace these long options with genericOption as per TSQL - many others in commonlex also.
CLIENT_ENABLE_LOG_INFO_STATEMENT_PARAMETERS   : 'CLIENT_ENABLE_LOG_INFO_STATEMENT_PARAMETERS';
CLIENT_ENCRYPTION_KEY_SIZE                    : 'CLIENT_ENCRYPTION_KEY_SIZE';
CLIENT_MEMORY_LIMIT                           : 'CLIENT_MEMORY_LIMIT';
CLIENT_METADATA_REQUEST_USE_CONNECTION_CTX    : 'CLIENT_METADATA_REQUEST_USE_CONNECTION_CTX';
CLIENT_METADATA_USE_SESSION_DATABASE          : 'CLIENT_METADATA_USE_SESSION_DATABASE';
CLIENT_PREFETCH_THREADS                       : 'CLIENT_PREFETCH_THREADS';
CLIENT_RESULT_CHUNK_SIZE                      : 'CLIENT_RESULT_CHUNK_SIZE';
CLIENT_RESULT_COLUMN_CASE_INSENSITIVE         : 'CLIENT_RESULT_COLUMN_CASE_INSENSITIVE';
CLIENT_SESSION_KEEP_ALIVE                     : 'CLIENT_SESSION_KEEP_ALIVE';
CLIENT_SESSION_KEEP_ALIVE_HEARTBEAT_FREQUENCY : 'CLIENT_SESSION_KEEP_ALIVE_HEARTBEAT_FREQUENCY';
CLIENT_TIMESTAMP_TYPE_MAPPING                 : 'CLIENT_TIMESTAMP_TYPE_MAPPING';
EXTERNAL_OAUTH                                : 'EXTERNAL_OAUTH';
EXTERNAL_OAUTH_ADD_PRIVILEGED_ROLES_TO_BLOCKED_LIST:
    'EXTERNAL_OAUTH_ADD_PRIVILEGED_ROLES_TO_BLOCKED_LIST'
;
EXTERNAL_OAUTH_ALLOWED_ROLES_LIST : 'EXTERNAL_OAUTH_ALLOWED_ROLES_LIST';
EXTERNAL_OAUTH_ANY_ROLE_MODE      : 'EXTERNAL_OAUTH_ANY_ROLE_MODE';
EXTERNAL_OAUTH_AUDIENCE_LIST      : 'EXTERNAL_OAUTH_AUDIENCE_LIST';
EXTERNAL_OAUTH_BLOCKED_ROLES_LIST : 'EXTERNAL_OAUTH_BLOCKED_ROLES_LIST';
EXTERNAL_OAUTH_ISSUER             : 'EXTERNAL_OAUTH_ISSUER';
EXTERNAL_OAUTH_JWS_KEYS_URL       : 'EXTERNAL_OAUTH_JWS_KEYS_URL';
EXTERNAL_OAUTH_RSA_PUBLIC_KEY     : 'EXTERNAL_OAUTH_RSA_PUBLIC_KEY';
EXTERNAL_OAUTH_RSA_PUBLIC_KEY_2   : 'EXTERNAL_OAUTH_RSA_PUBLIC_KEY_2';
EXTERNAL_OAUTH_SCOPE_DELIMITER    : 'EXTERNAL_OAUTH_SCOPE_DELIMITER';
EXTERNAL_OAUTH_SNOWFLAKE_USER_MAPPING_ATTRIBUTE:
    'EXTERNAL_OAUTH_SNOWFLAKE_USER_MAPPING_ATTRIBUTE'
;
EXTERNAL_OAUTH_TOKEN_USER_MAPPING_CLAIM        : 'EXTERNAL_OAUTH_TOKEN_USER_MAPPING_CLAIM';
EXTERNAL_OAUTH_TYPE                            : 'EXTERNAL_OAUTH_TYPE';
EXTERNAL_STAGE                                 : 'EXTERNAL_STAGE';
REQUIRE_STORAGE_INTEGRATION_FOR_STAGE_CREATION : 'REQUIRE_STORAGE_INTEGRATION_FOR_STAGE_CREATION';
REQUIRE_STORAGE_INTEGRATION_FOR_STAGE_OPERATION:
    'REQUIRE_STORAGE_INTEGRATION_FOR_STAGE_OPERATION'
;
// TOOD: Replace usage with genericOption(s)
REQUIRED_SYNCHRONIZED_SECONDARIES_TO_COMMIT: 'REQUIRED_SYNCHRONIZED_SECONDARIES_TO_COMMIT';

// Whitespace handling
WS: SPACE+ -> skip;

// Comments
SQL_COMMENT  : '/*' (SQL_COMMENT | .)*? '*/' -> channel(HIDDEN);
LINE_COMMENT : ('--' | '//') ~[\r\n]*        -> channel(HIDDEN);

// Identifiers
ID              : ( [A-Z_] | FullWidthLetter) ( [A-Z_#$@0-9] | FullWidthLetter)*;
DOUBLE_QUOTE_ID : '"' ('""' | ~[\r\n"])* '"';

// This lexer rule is needed so that any unknown character in the lexicon does not
// cause an incomprehensible error message from teh lexer. This rule will allow the parser to issue
// something more meaningful and perform error recovery as the lexer CANNOT raise an error - it
// will alwys match at least one character using this catch-all rule.
//
// !IMPORTANT! - Always leave this as the last lexer rule, before the mode definitions
BADCHAR: .;

// -------------------------------------------------------
// Fragments for use in other lexer rules
fragment LETTER      : [A-Z_];
fragment HEX_DIGIT   : [0-9A-F];
fragment DEC_DOT_DEC : [0-9]+ '.' [0-9]+ | [0-9]+ '.' | '.' [0-9]+;
fragment FullWidthLetter options {
    caseInsensitive = false;
}:
    '\u00c0' ..'\u00d6'
    | '\u00d8' ..'\u00f6'
    | '\u00f8' ..'\u00ff'
    | '\u0100' ..'\u1fff'
    | '\u2c00' ..'\u2fff'
    | '\u3040' ..'\u318f'
    | '\u3300' ..'\u337f'
    | '\u3400' ..'\u3fff'
    | '\u4e00' ..'\u9fff'
    | '\ua000' ..'\ud7ff'
    | '\uf900' ..'\ufaff'
    | '\uff00' ..'\ufff0'
; // | '\u20000'..'\u2FA1F'
fragment HexDigit  : [0-9a-f];
fragment HexString : [A-Z0-9|.] [A-Z0-9+\-|.]*;
fragment SPACE:
    [ \t\r\n\u000c\u0085\u00a0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000]+
;
