// =================================================================================
// Please reformat the grammr file before a change commit. See remorph/core/README.md
// For formatting, see: https://github.com/mike-lischke/antlr-format/blob/main/doc/formatting.md

// $antlr-format alignColons hanging
// $antlr-format columnLimit 150
// $antlr-format alignSemicolons hanging
// $antlr-format alignTrailingComments true
// =================================================================================

parser grammar commonparse;

keyword
    : ABORT
    | ABORT_AFTER_WAIT
    | ABSENT
    | ABSOLUTE
    | ACCENT_SENSITIVITY
    | ACCESS
    | ACCOUNTADMIN
    | ACTION
    | ACTIVATION
    | ACTIVE
    | ADD // ?
    | ADDRESS
    | ADMINISTER
    | AES
    | AES_128
    | AES_192
    | AES_256
    | AFFINITY
    | AFTER
    | AGGREGATE
    | ALERT
    | ALGORITHM
    | ALL_CONSTRAINTS
    | ALL_ERRORMSGS
    | ALL_INDEXES
    | ALL_LEVELS
    | ALLOW_CONNECTIONS
    | ALLOW_ENCRYPTED_VALUE_MODIFICATIONS
    | ALLOW_MULTIPLE_EVENT_LOSS
    | ALLOW_PAGE_LOCKS
    | ALLOW_ROW_LOCKS
    | ALLOW_SINGLE_EVENT_LOSS
    | ALLOW_SNAPSHOT_ISOLATION
    | ALLOWED
    | ALWAYS
    | ANONYMOUS
    | ANSI_DEFAULTS
    | ANSI_NULL_DEFAULT
    | ANSI_NULL_DFLT_OFF
    | ANSI_NULL_DFLT_ON
    | ANSI_NULLS
    | ANSI_PADDING
    | ANSI_WARNINGS
    | APPEND
    | APPLICATION
    | APPLICATION_LOG
    | APPLY
    | ARITHABORT
    | ARITHIGNORE
    | ARRAY
    | ARRAY_AGG
    | ASSEMBLY
    | ASYMMETRIC
    | ASYNCHRONOUS_COMMIT
    | AT_KEYWORD
    | AUDIT
    | AUDIT_GUID
    | AUTHENTICATE
    | AUTHENTICATION
    | AUTO
    | AUTO_CLEANUP
    | AUTO_CLOSE
    | AUTO_CREATE_STATISTICS
    | AUTO_DROP
    | AUTO_SHRINK
    | AUTO_UPDATE_STATISTICS
    | AUTO_UPDATE_STATISTICS_ASYNC
    | AUTOGROW_ALL_FILES
    | AUTOGROW_SINGLE_FILE
    | AUTOMATED_BACKUP_PREFERENCE
    | AUTOMATIC
    | AVAILABILITY
    | AVAILABILITY_MODE
    | BACKUP_CLONEDB
    | BACKUP_PRIORITY
    | BEFORE
    | BEGIN_DIALOG
    | BINARY
    | BINDING
    | BLOB_STORAGE
    | BLOCK
    | BLOCKERS
    | BLOCKSIZE
    | BODY
    | BROKER
    | BROKER_INSTANCE
    | BUFFER
    | BUFFERCOUNT
    | BULK_LOGGED
    | CACHE
    | CALLED
    | CALLER
    | CAP_CPU_PERCENT
    | CAST
    | CATALOG
    | CATCH
    | CERTIFICATE
    | CHANGE
    | CHANGE_RETENTION
    | CHANGE_TRACKING
    | CHANGES
    | CHANGETABLE
    | CHARACTER
    | CHECK_EXPIRATION
    | CHECK_POLICY
    | CHECKALLOC
    | CHECKCATALOG
    | CHECKCONSTRAINTS
    | CHECKDB
    | CHECKFILEGROUP
    | CHECKSUM
    | CHECKTABLE
    | CLASSIFIER_FUNCTION
    | CLEANTABLE
    | CLEANUP
    | CLONEDATABASE
    | CLUSTER
    | COLLATE
    | COLLECTION
    | COLUMN_ENCRYPTION_KEY
    | COLUMN_MASTER_KEY
    | COLUMNS
    | COLUMNSTORE
    | COLUMNSTORE_ARCHIVE
    | COMMENT
    | COMMITTED
    | COMPATIBILITY_LEVEL
    | COMPRESS_ALL_ROW_GROUPS
    | COMPRESSION
    | COMPRESSION_DELAY
    | CONCAT
    | CONCAT_NULL_YIELDS_NULL
    | CONDITION
    | CONFIGURATION
    | CONNECT
    | CONNECTION
    | CONTAINS
    | CONTAINMENT
    | CONTENT
    | CONTEXT
    | CONTINUE_AFTER_ERROR
    | CONTRACT
    | CONTRACT_NAME
    | CONTROL
    | CONVERSATION
    | COOKIE
    | COPY_ONLY
    | COPY_OPTIONS_
    | COUNTER
    | CPU
    | CREATE_NEW
    | CREATION_DISPOSITION
    | CREDENTIAL
    | CRYPTOGRAPHIC
    | CURRENT_TIME
    | CURSOR_CLOSE_ON_COMMIT
    | CURSOR_DEFAULT
    | CYCLE
    | DATA
    | DATA_COMPRESSION
    | DATA_PURITY
    | DATA_SOURCE
    | DATABASE_MIRRORING
    | DATASPACE
    | DATE_CORRELATION_OPTIMIZATION
    | DATE_FORMAT
    | DAYS
    | DB_CHAINING
    | DB_FAILOVER
    | DBCC
    | DBREINDEX
    | DDL
    | DECRYPTION
    | DEFAULT
    | DEFAULT_DATABASE
    | DEFAULT_DOUBLE_QUOTE
    | DEFAULT_FULLTEXT_LANGUAGE
    | DEFAULT_LANGUAGE
    | DEFAULT_SCHEMA
    | DEFINITION
    | DELAY
    | DELAYED_DURABILITY
    | DELETED
    | DELTA
    | DENSE_RANK
    | DEPENDENTS
    | DES
    | DESCRIPTION
    | DESX
    | DETERMINISTIC
    | DHCP
    | DIAGNOSTICS
    | DIALOG
    | DIFFERENTIAL
    | DIRECTION
    | DIRECTORY_NAME
    | DISABLE
    | DISABLE_AUTO_CONVERT
    | DISABLE_BROKER
    | DISABLED
    | DISTRIBUTION
    | DOCUMENT
    | DOWNSTREAM
    | DROP_EXISTING
    | DROPCLEANBUFFERS
    | DTC_SUPPORT
    | DUMMY
    | DYNAMIC
    | EDITION
    | ELEMENTS
    | EMAIL
    | EMERGENCY
    | EMPTY
    | ENABLE
    | ENABLE_BROKER
    | ENABLED
    | ENCRYPTED
    | ENCRYPTED_VALUE
    | ENCRYPTION
    | ENCRYPTION_TYPE
    | END
    | ENDPOINT
    | ENDPOINT_URL
    | ERROR
    | ERROR_BROKER_CONVERSATIONS
    | ESTIMATEONLY
    | EVENT
    | EVENT_RETENTION_MODE
    | EXCHANGE
    | EXCLUSIVE
    | EXECUTABLE
    | EXECUTABLE_FILE
    | EXPIREDATE
    | EXPIRY_DATE
    | EXPLICIT
    | EXTENDED_LOGICAL_CHECKS
    | EXTENSION
    | EXTERNAL
    | EXTERNAL_ACCESS
    | FAIL_OPERATION
    | FAILOVER
    | FAILOVER_MODE
    | FAILURE
    | FAILURE_CONDITION_LEVEL
    | FAILURECONDITIONLEVEL
    | FAN_IN
    | FAST_FORWARD
    | FILE_FORMAT
    | FILE_SNAPSHOT
    | FILEGROUP
    | FILEGROWTH
    | FILENAME
    | FILEPATH
    | FILESTREAM
    | FILESTREAM_ON
    | FILTER
    | FIRST
    | FIRST_NAME
    | FLATTEN
    | FLOOR
    | FMTONLY
    | FOLLOWING
    | FORCE
    | FORCE_FAILOVER_ALLOW_DATA_LOSS
    | FORCE_SERVICE_ALLOW_DATA_LOSS
    | FORCEPLAN
    | FORCESCAN
    | FORCESEEK
    | FORMAT
    | FORWARD_ONLY
    | FREE
    | FREQUENCY
    | FULLSCAN
    | FULLTEXT
    | FUNCTION
    | GB
    | GENERATED
    | GET
    | GETROOT
    | GLOBAL
    | GO
    | GOVERNOR
    | GROUP_MAX_REQUESTS
    | GROUPING
    | HADR
    | HASH
    | HASHED
    | HEALTH_CHECK_TIMEOUT
    | HEALTHCHECKTIMEOUT
    | HEAP
    | HIDDEN_KEYWORD
    | HIERARCHYID
    | HIGH
    | HONOR_BROKER_PRIORITY
    | HOURS
    | IDENTIFIER
    | IDENTITY
    | IDENTITY_VALUE
    | IF
    | IGNORE_CONSTRAINTS
    | IGNORE_DUP_KEY
    | IGNORE_REPLICATED_TABLE_CACHE
    | IGNORE_TRIGGERS
    | IIF
    | IMMEDIATE
    | IMPERSONATE
    | IMPLICIT_TRANSACTIONS
    | IMPORTANCE
    | INCLUDE
    | INCLUDE_NULL_VALUES
    | INCREMENT
    | INCREMENTAL
    | INDEX
    | INFINITE
    | INIT
    | INITIATOR
    | INPUT
    | INSENSITIVE
    | INSERT
    | INSERTED
    | INSTEAD
    | INTERVAL
    | IO
    | IP
    | ISOLATION
    | JOB
    | JSON
    | JSON_ARRAY
    | JSON_OBJECT
    | KB
    | KEEPDEFAULTS
    | KEEPIDENTITY
    | KERBEROS
    | KEY
    | KEY_PATH
    | KEY_SOURCE
    | KEY_STORE_PROVIDER_NAME
    | KEYS
    | KEYSET
    | KWSKIP
    | LANGUAGE
    | LAST
    | LAST_NAME
    | LAST_QUERY_ID
    | LEAD
    | LENGTH
    | LEVEL
    | LIBRARY
    | LIFETIME
    | LINKED
    | LINUX
    | LIST
    | LISTAGG
    | LISTENER
    | LISTENER_IP
    | LISTENER_PORT
    | LISTENER_URL
    | LOB_COMPACTION
    | LOCAL
    | LOCAL_SERVICE_NAME
    | LOCATION
    | LOCK
    | LOCK_ESCALATION
    | LOGIN
    | LOOP
    | LOW
    | MANUAL
    | MARK
    | MASK
    | MASKED
    | MASTER
    | MATCHED
    | MATCHES
    | MATERIALIZED
    | MAX
    | MAX_CONCURRENCY_LEVEL
    | MAX_CPU_PERCENT
    | MAX_DISPATCH_LATENCY
    | MAX_DOP
    | MAX_DURATION
    | MAX_EVENT_SIZE
    | MAX_FILES
    | MAX_IOPS_PER_VOLUME
    | MAX_MEMORY
    | MAX_MEMORY_PERCENT
    | MAX_OUTSTANDING_IO_PER_VOLUME
    | MAX_PROCESSES
    | MAX_QUEUE_READERS
    | MAX_ROLLOVER_FILES
    | MAX_SIZE
    | MAXSIZE
    | MAXTRANSFER
    | MAXVALUE
    | MB
    | MEDIADESCRIPTION
    | MEDIANAME
    | MEDIUM
    | MEMBER
    | MEMORY_OPTIMIZED_DATA
    | MEMORY_PARTITION_MODE
    | MESSAGE
    | MESSAGE_FORWARD_SIZE
    | MESSAGE_FORWARDING
    | MIN_CPU_PERCENT
    | MIN_IOPS_PER_VOLUME
    | MIN_MEMORY_PERCENT
    | MINUTES
    | MINVALUE
    | MIRROR
    | MIRROR_ADDRESS
    | MIXED_PAGE_ALLOCATION
    | MODE
    | MODIFY
    | MOVE
    | MULTI_USER
    | MUST_CHANGE
    | NAME
    | NESTED_TRIGGERS
    | NETWORK
    | NEW_ACCOUNT
    | NEW_BROKER
    | NEW_PASSWORD
    | NEWNAME
    | NEXT
    | NEXTVAL
    | NO
    | NO_CHECKSUM
    | NO_COMPRESSION
    | NO_EVENT_LOSS
    | NO_INFOMSGS
    | NO_QUERYSTORE
    | NO_STATISTICS
    | NO_TRUNCATE
    | NOCOUNT
    | NODES
    | NOEXEC
    | NOEXPAND
    | NOFORMAT
    | NOINDEX
    | NOINIT
    | NOLOCK
    | NON_TRANSACTED_ACCESS
    | NONE
    | NOORDER
    | NORECOMPUTE
    | NORECOVERY
    | NOREWIND
    | NOSKIP
    | NOTIFICATION
    | NOTIFICATIONS
    | NOUNLOAD
    | NTILE
    | NTLM
    | NUMANODE
    | NUMERIC_ROUNDABORT
    | OBJECT
    | OFF
    | OFFLINE
    | OFFSET
    | OLD_ACCOUNT
    | OLD_PASSWORD
    | ON
    | ON_FAILURE
    | ONLINE
    | ONLY
    | OPEN_EXISTING
    | OPENJSON
    | OPERATIONS
    | OPTIMISTIC
    | OPTION
    | ORDER
    | ORGADMIN
    | OUT
    | OUTBOUND
    | OUTER
    | OUTPUT
    | OVERRIDE
    | OWNER
    | OWNERSHIP
    | PAD_INDEX
    | PAGE
    | PAGE_VERIFY
    | PAGECOUNT
    | PAGLOCK
    | PARAM_NODE
    | PARAMETERIZATION
    | PARSEONLY
    | PARTIAL
    | PARTITION
    | PARTITIONS
    | PARTNER
    | PASSWORD
    | PATH
    | PATTERN
    | PAUSE
    | PDW_SHOWSPACEUSED
    | PER_CPU
    | PER_DB
    | PER_NODE
    | PERMISSION_SET
    | PERSIST_SAMPLE_PERCENT
    | PERSISTED
    | PHYSICAL_ONLY
    | PLATFORM
    | POISON_MESSAGE_HANDLING
    | POLICY
    | POOL
    | PORT
    | PRECEDING
    | PREDICATE
    | PRIMARY_ROLE
    | PRIOR
    | PRIORITY
    | PRIORITY_LEVEL
    | PRIVATE
    | PRIVATE_KEY
    | PRIVILEGES
    | PROCCACHE
    | PROCEDURE_NAME
    | PROCESS
    | PROFILE
    | PROPERTY
    | PROVIDER
    | PROVIDER_KEY_NAME
    | PUBLIC
    | QUERY
    | QUEUE
    | QUEUE_DELAY
    | QUOTED_IDENTIFIER
    | RANDOMIZED
    | RANGE
    | RANK
    | RC2
    | RC4
    | RC4_128
    | READ_COMMITTED_SNAPSHOT
    | READ_ONLY
    | READ_ONLY_ROUTING_LIST
    | READ_WRITE
    | READ_WRITE_FILEGROUPS
    | READCOMMITTED
    | READCOMMITTEDLOCK
    | READONLY
    | READPAST
    | READUNCOMMITTED
    | READWRITE
    | REBUILD
    | RECEIVE
    | RECOVERY
    | RECURSIVE
    | RECURSIVE_TRIGGERS
    | REGENERATE
    | REGION
    | RELATED_CONVERSATION
    | RELATED_CONVERSATION_GROUP
    | RELATIVE
    | REMOTE
    | REMOTE_PROC_TRANSACTIONS
    | REMOTE_SERVICE_NAME
    | REMOVE
    | REORGANIZE
    | REPAIR_ALLOW_DATA_LOSS
    | REPAIR_FAST
    | REPAIR_REBUILD
    | REPEATABLE
    | REPEATABLEREAD
    | REPLACE
    | REPLICA
    | REPLICATE
    | REQUIRED
    | RESAMPLE
    | RESERVE_DISK_SPACE
    | RESET
    | RESOURCE
    | RESOURCE_MANAGER_LOCATION
    | RESOURCES
    | RESPECT
    | RESTART
    | RESTRICT
    | RESTRICTED_USER
    | RESULT
    | RESUMABLE
    | RESUME
    | RETAINDAYS
    | RETENTION
    | RETURNS
    | REWIND
    | RLIKE
    | ROLE
    | ROOT
    | ROUND_ROBIN
    | ROUTE
    | ROW
    | ROWGUID
    | ROWLOCK
    | ROWS
    | RSA_512
    | RSA_1024
    | RSA_2048
    | RSA_3072
    | RSA_4096
    | SAFE
    | SAFETY
    | SAMPLE
    | SCHEDULER
    | SCHEMABINDING
    | SCHEME
    | SCOPED
    | SCRIPT
    | SCROLL
    | SCROLL_LOCKS
    | SEARCH
    | SECONDARY
    | SECONDARY_ONLY
    | SECONDARY_ROLE
    | SECONDS
    | SECRET
    | SECURABLES
    | SECURITY
    | SECURITY_LOG
    | SECURITYADMIN
    | SEEDING_MODE
    | SELF
    | SEMI_SENSITIVE
    | SEND
    | SENT
    | SEQUENCE
    | SEQUENCE_NUMBER
    | SERIALIZABLE
    | SERVER
    | SERVICE
    | SERVICE_BROKER
    | SERVICE_NAME
    | SERVICEBROKER
    | SESSION
    | SESSION_TIMEOUT
    | SETTINGS
    | SHARE
    | SHARED
    | SHARES
    | SHOWCONTIG
    | SHOWPLAN
    | SHOWPLAN_ALL
    | SHOWPLAN_TEXT
    | SHOWPLAN_XML
    | SHRINKLOG
    | SID
    | SIGNATURE
    | SINGLE_USER
    | SIZE
    | SNAPSHOT
    | SOFTNUMA
    | SORT_IN_TEMPDB
    | SOURCE
    | SP_EXECUTESQL
    | SPARSE
    | SPATIAL_WINDOW_MAX_CELLS
    | SPECIFICATION
    | SPLIT
    | SQLDUMPERFLAGS
    | SQLDUMPERPATH
    | SQLDUMPERTIMEOUT
    | STAGE
    | STANDBY
    | START
    | START_DATE
    | STARTED
    | STARTUP_STATE
    | STATE
    | STATIC
    | STATISTICS_INCREMENTAL
    | STATISTICS_NORECOMPUTE
    | STATS
    | STATS_STREAM
    | STATUS
    | STATUSONLY
    | STOP
    | STOP_ON_ERROR
    | STOPLIST
    | STOPPED
    | SUBJECT
    | SUBSCRIBE
    | SUBSCRIPTION
    | SUBSTRING
    | SUPPORTED
    | SUSPEND
    | SWITCH
    | SYMMETRIC
    | SYNCHRONOUS_COMMIT
    | SYNONYM
    | SYSADMIN
    | SYSTEM
    | TABLE
    | TABLERESULTS
    | TABLOCK
    | TABLOCKX
    | TAG
    | TAGS
    | TAKE
    | TAPE
    | TARGET
    | TARGET_LAG
    | TARGET_RECOVERY_TIME
    | TB
    | TCP
    | TEMP
    | TEXTIMAGE_ON
    | THROW
    | TIES
    | TIMEOUT
    | TIMER
    | TIMESTAMP
    | TIMEZONE
    | TORN_PAGE_DETECTION
    | TOSTRING
    | TRACE
    | TRACK_CAUSALITY
    | TRACKING
    | TRANSACTION_ID
    | TRANSFER
    | TRANSFORM_NOISE_WORDS
    | TRIPLE_DES
    | TRIPLE_DES_3KEY
    | TRUSTWORTHY
    | TRY
    | TRY_CAST
    | TSQL
    | TWO_DIGIT_YEAR_CUTOFF
    | TYPE
    | TYPE_WARNING
    | UNBOUNDED
    | UNCHECKED
    | UNCOMMITTED
    | UNLIMITED
    | UNLOCK
    | UNMASK
    | UNSAFE
    | UOW
    | UPDLOCK
    | URL
    | USED
    | USER
    | USERADMIN
    | VALID_XML
    | VALIDATION
    | VALUE
    | VALUES
    | VAR
    | VERBOSELOGGING
    | VERIFY_CLONEDB
    | VERSION
    | VIEW_METADATA
    | VISIBILITY
    | WAIT
    | WAIT_AT_LOW_PRIORITY
    | WAREHOUSE
    | WAREHOUSE_TYPE
    | WELL_FORMED_XML
    | WINDOWS
    | WITHOUT
    | WITHOUT_ARRAY_WRAPPER
    | WITNESS
    | WORK
    | WORKLOAD
    | XACT_ABORT
    | XLOCK
    | XML
    | XML_COMPRESSION
    | XMLDATA
    | XMLNAMESPACES
    | XMLSCHEMA
    | XSINIL
    | ZONE
    ;